<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

$submit = $_POST['submit'];
$preview = $_POST['preview'];
$commentuser = $_POST['commentuser'];
$comment = $_POST['comment'];
$commenttitle = $_POST['commenttitle'];
$eid = $_POST['eid'];
$ip = getenv('REMOTE_ADDR');
$entry_title = $_POST['entry_title'];
$entry = $_POST['entry'];
if ($submit && $comment && $commenttitle) {
	$commentuser = $a->checkAuth()?$a->getUsername():'Anonymous User';
	$commenttitle = htmlspecialchars($commenttitle, ENT_QUOTES);
	$comment = htmlspecialchars($comment, ENT_QUOTES);
	$commenttime = date('Y-m-d H:i:s');
	$sql = "INSERT INTO " . TABLE_PRE . "comments (eid, title, commenttime, username, comment, ip) VALUES ($eid,'$commenttitle','$commenttime','$commentuser','$comment','$ip')";
	$result = $db->query($sql);
	$smarty->assign(array(
			"show_comment_submitted" => "true",
			"L_COMMENT_ENTERED" => $lang['Comment_entered'],
			"L_RETURN_TO_ENTRY" => sprintf($lang['Return_to_entry'], "<a href=\"./past.php?eid=${eid}\">", "Here", "</a>"),
			"L_RETURN_TO_INDEX" => $lang['Return_to_index'])
	);
} elseif ($a->checkAuth() && !$comment_submitted) {
	if ($submit && $entry_title && $entry) {
		$entry = str_replace('|', ':', $entry );
		$entry = htmlspecialchars($entry, ENT_QUOTES);
		$entry_title = str_replace('|', ':', $entry_title );
		$entry_title = htmlspecialchars($entry_title, ENT_QUOTES );
		$entry_time = date('Y-m-d H:i:s');
		$username = $a->getUsername();
		$sql = "INSERT INTO " . TABLE_PRE . "journalness (entry_time, entry_title, entry, poster, ip) VALUES ('$entry_time','$entry_title','$entry','$username','$ip')";
		$result = $db->query($sql);
		$sql = "SELECT MAX(eid) FROM " . TABLE_PRE . "journalness WHERE poster = '" . $a->getUsername() . "'";
		$result = $db->query($sql);
		$row = $result->fetchRow();
		$result->free();
		$smarty->assign(array(
				"show_entry_submitted" => "true",
				"L_GO_TO_ENTRY" => sprintf($lang['Go_to_entry'], "<a href=\"./past.php?eid=${row[0]}\">", "Here", "</a>"),
				"L_RETURN_TO_INDEX" => $lang['Return_to_index'],
				"L_MESSAGE_ENTERED" => $lang['Message_entered'])
		);
	}elseif($preview && $entry_title && $entry ) {
		$entry = stripslashes($entry);
		$entry = str_replace('|', ':', $entry );
		$entry = htmlspecialchars($entry, ENT_QUOTES);
		$entry_preview = bbcodeToHtml($entry);
		$entry_title = stripslashes($entry_title);
		$entry_title = str_replace('|', ':', $entry_title );
		$entry_title = htmlspecialchars($entry_title, ENT_QUOTES );
		$entry_time = date('Y-m-d H:i:s');
		$entry_time = formatDate($entry_time);
		$username = $a->getUsername();
		$sql = "SELECT path, imagename FROM " . TABLE_PRE . "uploads WHERE poster = '$username'";
		$result = $db->query($sql);
		$pictures = array();
		$pictures['nothing'] = $lang['Select_picture'];
		while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$pictures[$myrow['path']] = $myrow['imagename'];
		}
		$result->free();

		$smarty->assign(array(
				"show_preview" => "true",
				"entry_title_preview" => $entry_title,
				"entry_preview" => $entry_preview,
				"L_POSTED_ON" => $lang['Posted_on'],
				"entry_time_preview" => $entry_time,
				"L_POSTED_BY" => $lang['Posted_by'],
				"user_preview" => $username,
				"L_CREATE_ENTRY_TITLE" => $lang['Create_entry_title'],
				"L_TITLE" => $lang['Title'],
				"L_ENTRY" => $lang['Entry'],
				"picture_options" => $pictures,
				"pictures" => nothing,
				"L_UPLOAD_IMAGE" => $lang['Upload_image'],
				"L_SUBMIT" => $lang['Submit'],
				"L_PREVIEW" => $lang['Preview'],
				"entry_value" => $entry,
				"entry_title_value" => $entry_title,
				"show_create_entry" => "true")
		);
	}
} elseif (!$a->checkAuth() && !$comment_submitted) {
	$smarty->assign(array(
			"show_not_logged_in" => "true",
			"L_NOT_LOGGED_IN" => $lang['Not_logged_in'],
			"L_LOGIN_LINK" => $lang['Login_link'])
	);
}
$smarty->display("$def_theme/entry.tpl");
?>
