<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');
$admin_theme = $def_theme;
if ($a->getUsername() == $admin_name) {
	
	$smarty->assign(array(
			"show_admin_links" => "true",
			"L_SUBMIT" => $lang['Submit'])
	);
	
	if(!$_SERVER['QUERY_STRING']){
		$sql = "SELECT * FROM " . TABLE_PRE . "journalness";
		$result = $db->query($sql);
		$total_posts = $result->numRows();
		$result->free();
		$sql = "SELECT * FROM " . TABLE_PRE . "users WHERE username != 'Anonymous User'";
		$result = $db->query($sql);
		$total_users = $result->numRows();
		$result->free();
		$sql = "SELECT * FROM " . TABLE_PRE . "comments";
		$result = $db->query($sql);
		$total_comments = $result->numRows();
		$result->free();
		$php_ver = phpversion();

		if(DBMS == "mysql"){
			$table_pre = str_replace("_", "\_", TABLE_PRE);
			$sql = "SHOW TABLE STATUS FROM " . DB_NAME . " LIKE '" . $table_pre . "%'";
			$result = $db->query($sql);
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$total_table_size += $row['Data_length'] + $row['Index_length'];
			}
			$result->free();

			if($total_table_size >= 1048576){
				$total_table_size = $total_table_size / 1048576;
				$total_table_size = number_format($total_table_size, 2);
				$total_table_size .= " MB";
			}elseif($total_table_size >= 1024){
				$total_table_size = $total_table_size / 1024;
				$total_table_size = number_format($total_table_size, 2);
				$total_table_size .= " KB";
			}else{
				$total_table_size = number_format($total_table_size, 2);
				$total_table_size .= " $lang[Bytes]";
			}
		}else{
			$total_table_size = $lang['Not_available'];
		}

		if(DBMS == "mysql"){
			$table_pre = str_replace("_", "\_", TABLE_PRE);
			$sql = "SHOW TABLE STATUS FROM " . DB_NAME . " LIKE '" . $table_pre . "uploads'";
			$result = $db->query($sql);
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$db_upload_size += $row['Data_length'] + $row['Index_length'];
			}
			$result->free();

			if($db_upload_size >= 1048576){
				$db_upload_size = $db_upload_size / 1048576;
				$db_upload_size = number_format($db_upload_size, 2);
				$db_upload_size .= " MB";
			}elseif($db_upload_size >= 1024){
				$db_upload_size = $db_upload_size / 1024;
				$db_upload_size = number_format($db_upload_size, 2);
				$db_upload_size .= " KB";
			}else{
				$db_upload_size = number_format($db_upload_size, 2);
				$db_upload_size .= " $lang[Bytes]";
			}
		}else{
			$db_upload_size = $lang['Not_available'];
		}

		switch(DBMS){
		case "pgsql":
			$sql = "SHOW SERVER_VERSION";
			$result = $db->query($sql);
			$row = $result->fetchRow();
			$db_info = "PostgreSQL ";
			$db_info .= $row[0];
			break;
		case "mysql":
			$sql = "SELECT VERSION()";
			$result = $db->query($sql);
			$row = $result->fetchRow();
			$db_info = "MySQL ";
			$db_info .= $row[0];
			break;
		default:
			$db_info = $lang['Not_available'];
		}

		function get_size($dir) {
			$totalsize = 0;
			if ($handle = @opendir($dir)) {
				while ($file = readdir($handle)) {
					if($file != "." && $file != "..") {
						if(@is_dir($dir."/".$file)) {
							$fileinfo = get_size($dir."/".$file);
							$totalsize += $fileinfo[2];
						} else {	
							$totalsize += @filesize($dir."/".$file);
						}
					}
				}
				closedir($handle);
			}
			$result[2] = $totalsize;
			return $result;
		}
		$uploads_size = get_size("uploads");
		$upload_folder_size = $uploads_size[2];
		if($upload_folder_size >= 1048576){
			$upload_folder_size = $upload_folder_size / 1048576;
			$upload_folder_size = number_format($upload_folder_size, 2);
			$upload_folder_size .= " MB";
		}elseif($upload_folder_size >= 1024){
			$upload_folder_size = $upload_folder_size / 1024;
			$upload_folder_size = number_format($upload_folder_size, 2);
			$upload_folder_size .= " KB";
		}else{
			$upload_folder_size = number_format($upload_folder_size, 2);
			$upload_folder_size .= " $lang[Bytes]";
		}
		if(!$upload_folder_size){
			$upload_folder_size = $lang['Not_available'];
		}

		$smarty->assign(array(
				"show_main_page" => "true",
				"L_WELCOME" => $lang['Welcome'],
				"L_SUBMIT" => $lang['Submit'],
				"L_STATISTICS_TITLE" => sprintf($lang[Statistics_title], $journaltitle),
				"L_TOTAL_JOURNAL_POSTS" => $lang['Total_journal_posts'],
				"TOTAL_JOURNAL_POSTS" => $total_posts,
				"L_TOTAL_COMMENTS" => $lang['Total_comments'],
				"TOTAL_COMMENTS" => $total_comments,
				"L_TOTAL_USERS" => $lang['Total_users'],
				"TOTAL_USERS" => $total_users,
				"L_TOTAL_TABLE_SIZE" => $lang['Total_table_size'],
				"TOTAL_TABLE_SIZE" => $total_table_size,
				"L_PHP_VER" => $lang['PHP_version'],
				"PHP_VER" => $php_ver,
				"L_J_VER" => $lang['Journalness_version'],
				"J_VER" => $version,
				"L_DB_INFO" => $lang['DB_type'],
				"DB_INFO" => $db_info,
				"L_UPLOAD_FOLDER_SIZE" => $lang['Upload_folder_size'],
				"UPLOAD_FOLDER_SIZE" => $upload_folder_size,
				"L_DB_UPLOAD_SIZE" => $lang['DB_upload_size'],
				"DB_UPLOAD_SIZE" => $db_upload_size)
		);
	}

	$useradmin = $_GET['useradmin'];
	$config = $_GET['configuration'];
	$verify = $_GET['verify'];
	$linksadmin = $_GET['linksadmin'];
	if (isset($useradmin)) {
		$uname = $_GET['username'];
		if ($uname) {
			$sql = "SELECT * FROM " . TABLE_PRE . "users WHERE username='$uname'";
			$result = $db->query($sql);
			$myrow = $result->fetchRow(DB_FETCHMODE_ASSOC);
			$result->free();
			$myrow[verified] == "1" ? $myrow[verified] = "<input type=\"radio\" name=\"verified\" value=\"1\" checked=\"checked\"> $lang[Yes] <input type=\"radio\" name=\"verified\" value=\"0\"> $lang[No]" : $myrow[verified] = "<input type=\"radio\" name=\"verified\" value=\"1\"> $lang[Yes] <input type=\"radio\" name=\"verified\" value=\"0\" checked=\"checked\"> $lang[No]";

			if($uname == $admin_name)
			{
				$smarty->assign(array(
							"L_ADMIN_NOTE" => $lang['Admin_note'])
							);
			}
			$smarty->assign(array(
					"show_edit_user" => "true",
					"L_EDITING_USER" => $lang['Editing_user'],
					"currentusername" => $uname,
					"newusername" => $uname,
					"password" => $myrow[password],
					"L_USERNAME" => $lang['Username'],
					"L_NEW_USERNAME" => $lang['New_username'],
					"L_NEW_PASSWORD" => $lang['New_password'],
					"L_CONFIRM" => $lang['Confirm'],
					"L_EMAIL_ADDRESS" => $lang['Email_address'],
					"L_EMAIL_PUBLIC" => $lang['Email_public'],
					"email_public" => $myrow[email_public],
					"user_email" => $myrow[email],
					"L_VERIFIED" => $lang['Verified'],
					"VERIFIED" => $myrow[verified],
					"L_YES" => $lang['Yes'],
					"L_NO" => $lang['No'],
					"L_USER_LANGUAGE" => $lang['User_language'],
					"L_USER_THEME" => $lang['User_theme'],
					"cust_options" => $languages,
					"theme_options" => $themes,
					"def_lang" => $myrow[def_user_lang],
					"def_theme" => $myrow[def_user_theme],
					"L_REAL_NAME" => $lang['Real_name'],
					"realname" => $myrow[realname],
					"L_AGE" => $lang['Age'],
					"age" => $myrow[age],
					"L_SEX" => $lang['Sex'],
					"L_MALE" => $lang['Male'],
					"L_FEMALE" => $lang['Female'],
					"sex" => $myrow[sex],
					"L_ICQ" => $lang['ICQ'],
					"icq" => $myrow[icq],
					"L_AIM" => $lang['AIM'],
					"aim" => $myrow[aim],
					"L_YIM" => $lang['YIM'],
					"yim" => $myrow[yim],
					"L_MSN" => $lang['MSN'],
					"msn" => $myrow[msn],
					"L_WEBSITE" => $lang['Website'],
					"website" => $myrow[website],
					"L_LOCATION" => $lang['Location'],
					"location" => $myrow[location])
			);
		} else {
			$sql = "SELECT uid, username, email, email_public, verified FROM " . TABLE_PRE . "users WHERE username != 'Anonymous User'";
			$result = $db->query($sql);
			$smarty->assign(array(
					"show_users_list" => "true",
					"show_add_user" => "true",
					"L_USERS" => $lang['Users'],
					"L_USERNAME_TITLE" => $lang['Username_title'],
					"L_EMAIL_TITLE" => $lang['Email_title'],
					"L_EMAIL_PUBLIC_TITLE" => $lang['Email_public_title'],
					"L_VERIFIED_TITLE" => $lang['Verified_title'],
					"L_POSTS_TITLE" => $lang['Posts_title'],
					"L_EDIT_TITLE" => $lang['Edit_title'],
					"L_DELETE" => $lang['Delete'],
					"L_ADMIN_ADD_USER" => $lang['Admin_add_user'],
					"L_USERNAME" => $lang['Username'],
					"L_PASSWORD" => $lang['Password'],
					"L_CONFIRM_PASSWORD" => $lang['Confirm_password'],
					"L_EMAIL_ADDRESS" => $lang['Email_address'],
					"L_EMAIL_PUBLIC" => $lang['Email_public'],
					"L_USER_LANGUAGE" => $lang['User_language'],
					"cust_options" => $languages,
					"L_VERIFIED" => $lang['Verified'],
					"L_YES" => $lang['Yes'],
					"L_NO" => $lang['No'])
			);
			if ($result->numRows()) {
				while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
					$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE poster = '$row[username]'";
					$query = $db->query($sql);
					$posts = $query->numRows();
					if($row[verified] == "1"){
						$row[verified] = $lang[Yes];
					}else{
						$row[verified] = "<a href=\"admin.php?verify={$row[uid]}\">$lang[No]</a>";
					}

					if($row[email_public] == "1"){
						$row[email_public] = $lang[Yes];
					}else{
						$row[email_public] = $lang[No];
					}

					if($posts == "0"){
						$row[posts] = $posts;
					}else{
						$row[posts] = "<a href=\"search.php?usr={$row[username]}\">{$posts}</a>";
					}

					$users[] = $row;
				}
				$smarty->assign('users', $users);
			}
			$result->free();
		}
	}
	if (isset($config)) {
		$submit_config = $_POST['submit_config'];
		if(isset($submit_config)){
			$_POST['journaltitle'] = htmlspecialchars($_POST['journaltitle']);

			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[journaltitle]' WHERE name = 'journaltitle'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[journaltype_select]' WHERE name = 'journaltype'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[anon_com_select]' WHERE name = 'anon_comment'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[newest_entries]' WHERE name = 'newest_entries'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[def_language_select]' WHERE name = 'def_language'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[def_theme_select]' WHERE name = 'def_theme'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[upload_type]' WHERE name = 'uploads'";
			$db->query($sql);
			$sql = "UPDATE " . TABLE_PRE . "config SET value = '$_POST[require_validation]' WHERE name = 'validation'";
			$db->query($sql);
			$smarty->assign(array(
					"show_config_updated" => "true",
					"L_CONFIG_UPDATED" => $lang['Config_updated'])
			);

		}else{
			$smarty->assign(array(
					"show_journal_config" => "true",
					"L_CONFIGURATION_TITLE" => $lang['Configuration_title'],
					"L_JOURNAL_TITLE" => $lang['Journal_title'],
					"JOURNALTITLE" => $journaltitle,
					"L_JOURNAL_TYPE" => $lang['Journal_type'],
					"L_NEWEST_ENTRIES" => $lang['Newest_entries'],
					"newest_entries" => $newest_entries,
					"L_DEF_LANGUAGE" => $lang['Def_language'],
					"L_DEF_THEME" => $lang['Def_theme'],
					"theme_options" => $themes,
					"L_UPLOAD_TYPE" => $lang['Upload_type'],
					"L_ANON_COM" => $lang['Anon_com'],
					"L_FILES" => $lang['Files'],
					"L_DATABASE" => $lang['Database'],
					"L_REQUIRE_VALIDATION" => $lang['Require_validation'],
					"L_GENERAL_CONFIG" => $lang['General_config'],
					"L_MORE_INFORMATION" => $lang['More_information'])
			);
			$smarty->assign('cust_options', array(
					0 => $lang['Open'],
					1 => $lang['Closed'],
					2 => $lang['Private']));
			$smarty->assign('journaltype_select', $journaltype);
			$smarty->assign('cust_radios', array(
					files => $lang['Files'],
					database => $lang['Database']));
			$smarty->assign('selected_upload_type', $uploads);
			$smarty->assign('cust_radios2', array(
					yes => $lang['Yes'],
					no => $lang['No']));
			$smarty->assign('selected_validation', $validation);		

			$lang_dir = "language/";

			$sql = "SELECT * FROM " . TABLE_PRE . "config";
			$result = $db->query($sql);
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				${$row[name]} = $row[value];
			}
			$result->free();

			$handle = opendir($lang_dir);
			while($file = readdir($handle)) {
				if ($file=='.' || $file=='..'){
		
				}else{
     	 			$completepath = "$lang_dir/$file";
     	      			if (is_dir($completepath)) {
						$handle2 = opendir($completepath);
						while($file2 = readdir($handle2)){
							if ($file2 == '.' || $file2 == '..'){
					
							}else{
								$completepath="$completepath/$file2";
								if(is_dir($completepath)){
								
								}else{
									$language = substr($file2, 0, -4);
									$language = strstr($language, '_');
									$language = str_replace("_", "", $language);
									$languages[] = $language;
									$display = ucfirst($language);
									if($def_language == $language){
										$options .= "<option value=\"$language\" selected=\"selected\">$display</option>\n\t\t";
									}else{
										$options .= "<option value=\"$language\">$display</option>\n\t\t";
									}
								}
							}
						}
          			  } else {
						$language = substr($file, 0, -4);
						$language = strstr($language, '_');
						$language = str_replace("_", "", $language);
						$languages[] = $language;
						$display = ucfirst($language);
						if($def_language == $language){
							$options .= "<option value=\"$language\" selected=\"selected\">$display</option>\n\t\t";
						}else{
							$options .= "<option value=\"$language\">$display</option>\n\t\t";
						}
					}
				}
			}
			$smarty->assign(array(
					"language_options" => $options,
					"def_theme" => $def_theme,
					"com_set" => $anon_comment,
					"com_opt" => $anon_com_opt)
			);
		}
	}
	if (isset($verify)) {
		$yes = $_POST['yes'];
		$no = $_POST['no'];
		$uid = $_POST['uid'];

		if(isset($yes) && isset($uid)){
			$sql = "UPDATE " . TABLE_PRE . "users SET verified = '1' WHERE uid = '$uid'";
			$db->query($sql);
			$smarty->assign(array(
					"show_verified" => "true",
					"L_USER_VERIFIED" => $lang['User_verified'],
					"L_RETURN_TO_USER_ADMIN" => $lang['Return_to_user_admin'])
			);
		}elseif(isset($no)){
			header('Location: admin.php?useradmin');
		}else{
			$sql = "SELECT username FROM " . TABLE_PRE . "users WHERE uid = '$verify'";
			$result = $db->query($sql);
			$row = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$result->free();
			$smarty->assign(array(
					"show_confirm_verify" => "true",
					"L_CONFIRM_VERIFY" => sprintf($lang[Confirm_verify], $row[0]),
					"L_YES" => $lang['Yes'],
					"L_NO" => $lang['No'],
					"UID" => $verify)
			);
		}
	}
	if(isset($linksadmin)){
		$mode = $_GET['mode'];
		$add_category = $_POST['add_category'];
		$add_link = $_POST['add_link'];
		if($mode == "moveup"){
			$linkid = $_GET['linkid'];
			$sql = "SELECT location FROM " . TABLE_PRE . "links WHERE linkid = '$linkid'";
			$result = $db->query($sql);
			$row = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$result->free();
			$row[0] += 1;
			$sql = "UPDATE " . TABLE_PRE . "links SET location = '$row[0]' WHERE linkid = '$linkid'";
			$db->query($sql);
			header('Location: admin.php?linksadmin');
		}elseif($mode == "movedown"){
			$linkid = $_GET['linkid'];
			$sql = "SELECT location FROM " . TABLE_PRE . "links WHERE linkid = '$linkid'";
			$result = $db->query($sql);
			$row = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$result->free();
			$row[0] -= 1;
			$sql = "UPDATE " . TABLE_PRE . "links SET location = '$row[0]' WHERE linkid = '$linkid'";
			$db->query($sql);
			header('Location: admin.php?linksadmin');
		}elseif($mode == "edit"){
			if(isset($_POST['edit_link'])){
				$name = $_POST['link_name'];
				$value = $_POST['link_value'];
				$category = $_POST['category'];
				$linkid = $_POST['linkid'];
				$visible = $_POST['visible'];
				if(isset($visible)){
					$visible = "1";
				}else{
					$visible = "0";
				}
				$sql = "UPDATE " . TABLE_PRE . "links SET name = '$name', value = '$value', incategory = '$category', visible = '$visible' WHERE linkid = '$linkid'";
				$db->query($sql);
				$smarty->assign(array(
						"show_link_updated" => "true",
						"L_LINK_UPDATED" => $lang['Link_updated'],
						"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
				);
			}elseif(isset($_POST['edit_category'])){
				$name = $_POST['category_name'];
				$linkid = $_POST['linkid'];
				$visible = $_POST['visible'];
				if(isset($visible)){
					$visible = "1";
				}else{
					$visible = "0";
				}
				$sql = "UPDATE " . TABLE_PRE . "links SET name = '$name', visible = '$visible' WHERE linkid = '$linkid'";
				$db->query($sql);
				$smarty->assign(array(
						"show_category_updated" => "true",
						"L_CATEGORY_UPDATED" => $lang['Category_updated'],
						"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
				);
			}else{
				$linkid = $_GET['linkid'];
				$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE linkid = '$linkid'";
				$result = $db->query($sql);
				$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
				$result->free();
				if($row[iscategory] == "1"){
					$row[visible] == "1" ? $row[visible] = "<input type=\"checkbox\" name=\"visible\" value=\"1\" checked=\"checked\">" : $row[visible] = "<input type=\"checkbox\" name=\"visible\" value=\"0\">";
					$smarty->assign(array(
							"show_edit_category" => "true",
							"L_EDIT_CATEGORY" => $lang['Edit_category'],
							"L_ADD_CATEGORY_NAME" => $lang['Add_category_name'],
							"CATEGORY_NAME" => $row[name],
							"L_VISIBLE" => $lang['Visible'],
							"VISIBLE_VALUE" => $row[visible],
							"linkid" => $row[linkid])
					);
				}else{
					$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE iscategory = '1'";
					$result = $db->query($sql);
					while($row2 = $result->fetchRow(DB_FETCHMODE_ASSOC)){
						$categories[$row2[linkid]] = $row2[name];
					}
					$result->free();
					$row[visible] == "1" ? $row[visible] = "<input type=\"checkbox\" name=\"visible\" value=\"1\" checked=\"checked\">" : $row[visible] = "<input type=\"checkbox\" name=\"visible\" value=\"0\">";
					$smarty->assign(array(
							"show_edit_link" => "true",
							"L_EDIT_LINK" => $lang['Edit_link'],
							"L_ADD_LINK_NAME" => $lang['Add_link_name'],
							"L_ADD_LINK_VALUE" => $lang['Add_link_value'],
							"L_WEB_EXAMPLE" => $lang['Web_example'],
							"L_ADD_LINK_CATEGORY" => $lang['Add_link_category'],
							"LINK_NAME" => $row[name],
							"LINK_VALUE" => $row[value],
							"linkid" => $row[linkid],
							"L_VISIBLE" => $lang['Visible'],
							"VISIBLE_VALUE" => $row[visible],
							"category_options" => $categories,
							"category" => $row[incategory])
					);
				}
			}
		}elseif($mode == "delete"){
			$confirm = $_GET['confirm'];
			$linkid = $_GET['linkid'];
			if($linkid){
				$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE incategory = '$linkid'";
				$result = $db->query($sql);
			}
			if($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$smarty->assign(array(
						"show_links_in_category" => "true",
						"L_ERROR" => $lang['Error'],
						"L_LINKS_IN_CATEGORY" => $lang['Links_in_category'],
						"linkid" => $linkid,
						"L_DELETE" => $lang['Delete'],
						"L_GO_BACK" => $lang['Go_back'])
				);
			}elseif($confirm == "yes"){
				if($_POST['delete_category']){
					$sql = "SELECT min(linkid) FROM " . TABLE_PRE . "links WHERE iscategory = '1'";
					$result = $db->query($sql);
					$min_category = $result->fetchrow(DB_FETCHMODE_ORDERED);
					if($_POST[linkid] != $min_category[0]){
						$sql = "DELETE FROM " . TABLE_PRE . "links WHERE linkid = '$_POST[linkid]'";
						$db->query($sql);
						$sql = "DELETE FROM " . TABLE_PRE . "links WHERE incategory = '$_POST[linkid]'";
						$db->query($sql);
					}
					$smarty->assign(array(
							"show_link_removed" => "true",
							"L_LINK_REMOVED" => $lang['Link_removed'],
							"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
					);
				}
			}else{
				if($_POST['delete_link']){
					$sql = "SELECT min(linkid) FROM " . TABLE_PRE . "links WHERE iscategory = '1'";
					$result = $db->query($sql);
					$min_category = $result->fetchrow(DB_FETCHMODE_ORDERED);
					if($_POST[linkid] != $min_category[0]){
						$sql = "DELETE FROM " . TABLE_PRE . "links WHERE linkid = '$_POST[linkid]'";
						$db->query($sql);
					}
					$smarty->assign(array(
							"show_link_removed" => "true",
							"L_LINK_REMOVED" => $lang['Link_removed'],
							"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
					);
				}else{
					$smarty->assign(array(
							"show_confirm_delete" => "true",
							"L_CONFIRM_DELETE" => $lang['Confirm_delete'],
							"linkid" => $linkid,
							"L_DELETE" => $lang['Delete'],
							"L_GO_BACK" => $lang['Go_back'])
					);
				}
			}
		}elseif(isset($add_category)){
			$category_name = $_POST['category_name'];
			$location = $_POST['location'];
			$visible = $_POST['visible'];
			if(isset($visible)){
				$visible = "1";
			}else{
				$visible = "0";
			}
			$sql = "INSERT INTO " . TABLE_PRE . "links (name, iscategory, location, visible) VALUES ('$category_name', '1', '$location', '$visible')";
			$db->query($sql);
			$smarty->assign(array(
					"show_category_added" => "true",
					"L_CATEGORY_ADDED" => $lang['Category_added'],
					"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
			);
		}elseif(isset($add_link)){
			$link_name = $_POST['link_name'];
			$link_value = $_POST['link_value'];
			$visible = $_POST['visible'];
			if(isset($visible)){
				$visible = "1";
			}else{
				$visible = "0";
			}
			$category = $_POST['category'];

			$sql = "SELECT max(location) FROM " . TABLE_PRE . "links WHERE incategory = '$category'";
			$result = $db->query($sql);
			$location = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$location[0] += 1;

			if(strstr($link_value, 'http://')){
			}else{
				$link_value = preg_replace("#((www|ftp)\.[^ \"\n\r\t<]*?)#is", "http://\\1", $link_value );
			}
			$sql = "INSERT INTO " . TABLE_PRE . "links (name, value, iscategory, incategory, location, visible) VALUES ('$link_name', '$link_value', '0', '$category', '$location[0]', '$visible')";
			$db->query($sql);
			$smarty->assign(array(
					"show_link_added" => "true",
					"L_LINK_ADDED" => $lang['Link_added'],
					"L_RETURN_TO_LINK_ADMIN" => $lang['Return_to_link_admin'])
			);
		}else{
			$sql = "SELECT * FROM " . TABLE_PRE . "links ORDER BY location ASC";
			$result = $db->query($sql);
			if ($result->numRows()) {
				while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
					if($row['iscategory'] == "1"){
						$row['iscategory'] = "Yes";
						$row['visible'] == "1" ? $row['visible'] = "Yes" : $row['visible'] = "No";
						$row['name'] = "<strong>${row[name]}</strong>";
						$row['value'] = "_________________";
						$links[] = $row;
						$sql = "SELECT * FROM " . TABLE_PRE . "links WHERE incategory = '$row[linkid]' ORDER BY location ASC";
						$result2 = $db->query($sql);
						while ($row2 = $result2->fetchRow(DB_FETCHMODE_ASSOC)){
							$row2['visible'] == "1" ? $row2['visible'] = "Yes" : $row2['visible'] = "No";
							if(!$row2['value']){
								$row2['value'] = "_________________";
							}else{
								$row_name = $row2['value'];
								strlen($row_name) > 25 ? $row_name = substr_replace($row_name, '...', 25) : '';
								$row2['value'] = "<a href=\"${row2[value]}\">${row_name}</a>";
							}
							if($row2['incategory']){
								$sql = "SELECT name FROM " . TABLE_PRE . "links WHERE linkid = '$row2[incategory]'";
								$query = $db->query($sql);
								$categoryname = $query->fetchRow(DB_FETCHMODE_ORDERED);
								$row2['incategory'] = $categoryname[0];
							}
							$row2['iscategory'] = "No";
							$links[] = $row2;
						}
					}
				}
				$result->free();
				$sql = "SELECT min(linkid) FROM " . TABLE_PRE . "links WHERE iscategory = '1'";
				$result = $db->query($sql);
				$first_category = $result->fetchRow(DB_FETCHMODE_ORDERED);
				$result->free();
				$sql = "SELECT location, name, linkid FROM " . TABLE_PRE . "links WHERE iscategory = '1' ORDER BY location ASC";
				$result = $db->query($sql);
				$sql = "SELECT min(location) FROM " . TABLE_PRE . "links";
				$result2 = $db->query($sql);
				$min_location = $result2->fetchRow(DB_FETCHMODE_ORDERED);
				$min_location[0] -= 1;
				$result2->free();
				$categories[$min_location[0]] = "First";
				while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
					$row2[name] = $row[name];
					$row[name] = "After " . $row[name] . "";
					$row[location] += 1;
					$categories[$row[location]] = $row[name];
					$categories2[$row[linkid]] = $row2[name];
				}
				$result->free();
				$smarty->assign(array(
					"show_links_list" => "true",
					"show_add_category" => "true",
					"show_add_link" => "true",
					"L_CATEGORIES_AND_LINKS" => $lang['Categories_and_links'],
					"L_LINK_ID" => $lang['Link_ID'],
					"L_LINK_NAME" => $lang['Link_name'],
					"L_LINK_VALUE" => $lang['Link_value'],
					"L_IS_CATEGORY" => $lang['Is_category'],
					"L_IN_CATEGORY" => $lang['In_category'],
					"L_EDIT_TITLE" => $lang['Edit_title'],
					"L_DELETE" => $lang['Delete'],
					"links" => $links,
					"FIRST_CATEGORY" => $first_category[0],
					"L_ADD_CATEGORY" => $lang['Add_category'],
					"L_ADD_LINK" => $lang['Add_link'],
					"L_ADD_CATEGORY_NAME" => $lang['Add_category_name'],
					"L_MOVE" => $lang['Move'],
					"L_VISIBLE" => $lang['Visible'],
					"L_LOCATION" => $lang['Location'],
					"cust_options" => $categories,
					"L_ADD_LINK_NAME" => $lang['Add_link_name'],
					"L_ADD_LINK_VALUE" => $lang['Add_link_value'],
					"L_WEB_EXAMPLE" => $lang['Web_example'],
					"L_ADD_LINK_CATEGORY" => $lang['Add_link_category'],
					"link_options" => $categories2)
				);
			}
		}
	}
} else {
	$smarty->assign(array(
			"show_not_admin" => "true",
			"L_ERROR" => $lang['Error'],
			"L_NOT_ADMIN" => $lang['Not_admin'])
	);
}
$smarty->display("$admin_theme/adminpanel.tpl");
?>
