<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if ($a->checkAuth()) {
	$submit = $_POST['submit'];
	$preview = $_POST['preview'];
	$entry = $_POST['entry'];
	$entry_title = $_POST['entry_title'];
	$entry_time = $_POST['entry_time'];
	$eid = $_POST['eid'];
	$user = $_POST['user'];
	$edit_comment = $_POST['edit_comment'];
	$comment_title = $_POST['commenttitle'];
	$comment = $_POST['comment'];
	$cid = $_POST['cid'];
	if ($a->getUsername() == $user || $a->getUsername() == $admin_name) {
		if ($edit_comment) {
			if ((!$comment_title) || (!$comment)) {
				$smarty->assign('show_fields_missing', 'true');
			} else {
				if ($a->getUsername() == $admin_name) {
					$comment = str_replace('|', ':', $comment );
					$comment = htmlspecialchars($comment, ENT_QUOTES);
					$comment_title = str_replace('|', ':', $comment_title );
					$comment_title = htmlspecialchars($comment_title, ENT_QUOTES );
					$sql = "UPDATE " . TABLE_PRE . "comments SET comment='$comment',title='$comment_title' WHERE commentid=$cid";
					$result = $db->query($sql);
					$comment_title = str_replace('\\', '', $comment_title);
					$smarty->assign(array(
							"show_comment_modified" => "true",
							"L_COMMENT_CHANGES_MADE" => sprintf($lang['Comment_changes_made'], $comment_title),
							"L_RETURN_TO_ENTRY" => sprintf($lang['Return_to_entry'], "<a href=\"past.php?eid=${eid}#comments\">", "Here", "</a>"),
							"eid" => $eid)
					);
				} else {
					$smarty->assign(array(
							"show_not_allowed" => "true",
							"L_NOT_ALLOWED" => $lang['Not_allowed'])
					);
				}
			}
		} else {
			if ($submit) {
				$entry = str_replace('|', ':', $entry );
				$entry = htmlspecialchars($entry, ENT_QUOTES);
				$entry_title = str_replace('|', ':', $entry_title );
				$entry_title = htmlspecialchars($entry_title, ENT_QUOTES );
				$sql = "UPDATE " . TABLE_PRE . "journalness SET entry='$entry',entry_title='$entry_title' WHERE eid=$eid";
				$result = $db->query($sql);
				$entry_title = str_replace('\\', '', $entry_title);
				$smarty->assign(array(
						"show_entry_modified" => "true",
						"L_ENTRY_CHANGES_MADE" => sprintf($lang['Entry_changes_made'], $entry_title),
						"L_RETURN_TO_ENTRY" => sprintf($lang['Return_to_entry'], "<a href=\"past.php?eid=${eid}\">", "Here", "</a>"))
				);
			} elseif($preview) {
				$entry = stripslashes($entry);
				$entry = str_replace('|', ':', $entry );
				$entry = htmlspecialchars($entry, ENT_QUOTES);
				$entry_preview = bbcodeToHtml($entry);
				$entry_title = stripslashes($entry_title);
				$entry_title = str_replace('|', ':', $entry_title );
				$entry_title = htmlspecialchars($entry_title, ENT_QUOTES );
				$entry_title = str_replace('\\', '', $entry_title);
				$sql = "SELECT path, imagename FROM " . TABLE_PRE . "uploads WHERE poster = '".$a->getUsername()."'";
				$result = $db->query($sql);
				$pictures = array();
				$pictures['nothing'] = $lang['Select_picture'];
				while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
					$pictures[$myrow['path']] = $myrow['imagename'];
				}
				$result->free();
				$smarty->assign(array(
						"picture_options" => $pictures,
						"pictures" => "nothing",
						"show_modify_entry" => "true",
						"show_preview" => "true",
						"entry_title" => $entry_title,
						"entry_time" => $entry_time,
						"eid" => $eid,
						"user" => $user,
						"entry" => $entry,
						"entry_preview" => $entry_preview,
						"entry_title_preview" => $entry_title,
						"entry_time_preview" => $entry_time,
						"user_preview" => $user,
						"L_POSTED_ON" => $lang['Posted_on'],
						"L_POSTED_BY" => $lang['Posted_by'],
						"L_EDITING_ENTRY" => $lang['Editing_entry'],
						"L_ENTERED_ON" => $lang['Entered_on'],
						"L_TITLE" => $lang['Title'],
						"L_ENTRY" => $lang['Entry'],
						"L_UPLOAD_IMAGE" => $lang['Upload_image'],
						"L_PREVIEW_CHANGES" => $lang['Preview_changes'],
						"L_SUBMIT_CHANGES" => $lang['Submit_changes'],
						"L_GO_BACK" => $lang['Go_back'])
				);
			}
		}
	} else {
		$smarty->assign(array(
				"show_not_allowed" => "true",
				"L_NOT_ALLOWED" => $lang['Not_allowed'])
		);	}
} else {
	$smarty->assign(array(
			"show_not_logged_in" => "true",
			"L_NOT_LOGGED_IN_EDIT" => $lang['Not_logged_in_edit'],
			"L_LOGIN_LINK" => $lang['Login_link'])
	);
}
$smarty->display("$def_theme/modify.tpl");
?>
