<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

if (@file_exists('config.php')) {
	include("config.php");
}

if (!defined("INSTALLED") ) {
	header("Location: install/install.php");
	exit;
}
$submit = $_POST['submit'];
$removedir = $_POST['removedir'];
if ($submit && $removedir) {
        $dir = "install";
        function deldir($dir){
                $current_dir = opendir($dir);
                while ($entryname = readdir($current_dir)) {
                        if (is_dir("$dir/$entryname") and ($entryname != "." and $entryname != "..")) {
                                deldir("${dir}/${entryname}");
                        } elseif($entryname != "." and $entryname != "..") {
                                unlink("${dir}/${entryname}");
                        }
                }
                closedir($current_dir);
                if (rmdir(${dir})){
                        header("Location: index.php");
                } else {
                        die($lang['Manually_remove_install_dir']);
                }
        }
        deldir($dir);
}
if (file_exists('install')) {
	global $journaltype, $def_theme, $def_language, $journaltitle, $a;
	require './libs/Smarty.class.php';
	require_once(SMARTY_DIR."Config_File.class.php");
	require_once('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');
	$smarty = new Smarty;

	$smarty->assign(array(
			"theme" => $def_theme,
			"L_JOURNAL_LINKS" => $lang['Journal_links'],
			"L_LOGIN" => $lang['Login'],
			"L_LOGOUT" => sprintf($lang['Logout'], "$current_username"),
			"L_HOME" => $lang['Home'],
			"L_ALL_ENTRIES" => $lang['All_entries'],
			"L_MY_ENTRIES" => $lang['My_entries'],
			"L_CREATE_ENTRY" => $lang['Create_entry'],
			"L_MY_PROFILE" => $lang['My_profile'],
			"L_MY_CLIP" => $lang['My_clip'],
			"L_MY_PANEL" => $lang['My_panel'],
			"L_ADMIN_PANEL" => $lang['Admin_panel'],
			"L_REGISTER" => $lang['Register'],
			"L_ADMIN_PANEL_LINKS" => $lang['Admin_panel_links'],
			"L_USER_PANEL_LINKS" => $lang['My_panel'],
			"L_EDIT_SIG" => $lang['Edit_sig'],
			"L_ADD_USER" => $lang['Add_user'],
			"L_USER_ADMIN" => $lang['User_admin'],
			"L_BACKUP" => $lang['Backup'],
			"L_CHANGE_JOURNAL_TYPE" => $lang['Change_journal_type'],
			"L_CHANGE_TITLE" => $lang['Change_title'],
			"L_CHANGE_NEWEST_ENTRIES" => $lang['Change_newest_entries'],
			"L_BLOGGERS" => $lang['Bloggers'],
			"L_POWERED_BY" => sprintf($lang['Powered_by'], "<a href=\"http://journalness.sourceforge.net\" onclick=\"window.open(this.href); return false;\">", "</a>",""),
			"L_QUICK_SEARCH" => $lang['Quick_search'],
			"L_SEARCH" => $lang['Search'],
			"JOURNALTYPE" => $journaltype,
			"JOURNALTITLE" => $journaltitle)
	);

	if ($journaltype == 2) {
		$smarty->assign('show_private_journal', 'true');
	}
	$smarty->display("$def_theme/header.tpl");
	$smarty->display("$def_theme/navigation.tpl");
	echo "<div class=\"centered\"><h2>$lang[Remove_install_dir]</h2><br/><br/>
		<form method=\"post\" action=\"./\">
		<p><input type=\"submit\" name=\"submit\" value=\"$lang[Remove_install_dir_button]\">
		<input type=\"hidden\" name=\"removedir\" value=\"removedir\"></p></div></td></tr>";
	exit;
}

$lang_dir = "language/";

$handle = opendir($lang_dir);
while($file = readdir($handle)) {
	if ($file=='.' || $file=='..'){

	}else{
   	 	$completepath = "$lang_dir/$file";
           	if (is_dir($completepath)) {
			$handle2 = opendir($completepath);
			while($file2 = readdir($handle2)){
				if ($file2 == '.' || $file2 == '..'){
				
				}else{
					$completepath="$completepath/$file2";
					if(is_dir($completepath)){
				
					}else{
						$language = substr($file2, 0, -4);
						$language = strstr($language, '_');
						$language = str_replace("_", "", $language);
						$languages[${language}] = ucfirst($language);
					}
				}
			}
            } else {
			$language = substr($file, 0, -4);
			$language = strstr($language, '_');
			$language = str_replace("_", "", $language);
			$languages[${language}] = ucfirst($language);
		}
	}	
}







$theme_dir = "templates/";

$handle = opendir($theme_dir);
while($file = readdir($handle)) {
	if ($file=='.' || $file=='..'){

	}else{
   	 	$completepath = "$theme_dir/$file";
           	if (is_dir($completepath)) {
						#$themer = substr($file2, 0, -4);
						#$themer = strstr($themer, '_');
						#$themer = str_replace("_", "", $themer);
						$themer = $file;
						$themes[${themer}] = ucfirst($themer);
		}
	}	
}



function formatDate($val) {
	$arr = explode("-", $val);
	$arr2 = explode(":", $val);
	$arr3 = explode(" ", $arr2[0]);
	return date("l, F j, Y @ g:i a", mktime($arr3[1], $arr2[1], $arr2[2], $arr[1], $arr[2], $arr[0]));
}

function bbcodeToHtml($entry) {
	// Thanks to Alexander Palmo's sphpblog and to phpBB2 for this script
	// Strip out pipes and HTML-ize entities. Use charset from the
	// language file to make sure we're only encoding stuff that
	// needs to be encoded.
	$tag_arr = array();
	array_push($tag_arr, '[i]', '<em>', '[/i]', '</em>');
	array_push($tag_arr, '[I]', '<em>', '[/I]', '</em>');
	array_push($tag_arr, '[b]', '<strong>', '[/b]', '</strong>');
	array_push($tag_arr, '[B]', '<strong>', '[/B]', '</strong>');
	array_push($tag_arr, '[u]', '<span style="text-decoration : underline;">', '[/u]', '</span>');
	array_push($tag_arr, '[U]', '<span style="text-decoration : underline;">', '[/U]', '</span>');
	array_push($tag_arr, chr(10), '<br/>' . chr(13) );
	for ($i = 0; $i < count($tag_arr );
	$i = $i + 2 ) {
		$entry = str_replace($tag_arr[$i], $tag_arr[$i+1], $entry);
	}
	$entry = preg_replace("#\[url=((www|ftp)\.[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is", "<a href=\"http://\\1\" onclick=\"window.open(this.href); return false;\">\\3</a>", $entry );
	$entry = preg_replace("#\[url=([\w]+?://[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is", "<a href=\"\\1\" onclick=\"window.open(this.href); return false;\">\\2</a>", $entry );
	$entry = preg_replace("#\[url\]((www|ftp)\.[^ \"\n\r\t<]*?)\[/url\]#is", "<a href=\"http://\\1\" onclick=\"window.open(this.href); return false;\">\\1</a>", $entry );
	$entry = preg_replace("#\[url\]([\w]+?://[^ \"\n\r\t<]*?)\[/url\]#is", "<a href=\"\\1\" onclick=\"window.open(this.href); return false;\">\\1</a>", $entry );
	$entry = preg_replace("#\[img]((www|ftp)\.[^ \"\n\r\t<]*?)\[/img]#si", "<img src=\"http://\\1\" alt=\"User Posted Image\"/>", $entry);
	$entry = preg_replace("#\[img](.*?)\[/img]#si", "<img src=\"\\1\" alt=\"User Posted Image\"/>", $entry);
	return $entry;
}

/*
 * Determines whether or not to display the login
 * form or to show the user that he is logged in
 * based on if the session variables are set.
 */
function displayLogin() {
	global $logged_in, $smarty, $a, $def_theme, $def_language, $journaltype;

	include('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');

	$smarty->assign('logged_in', $a->checkAuth());
	if ($a->checkAuth()) {
		$smarty->assign(array(
				"theme" => $def_theme,
				"show_logged_in" => "true",
				"L_LOGGED_IN" => $lang['Logged_in'],
				"L_USER_LOGGED_IN" => sprintf($lang['User_logged_in'], $a->getUsername()),
				"L_RETURN_TO_INDEX" => $lang['Return_to_index'])
		);
	} else {
		$smarty->assign(array(
				"theme" => $def_theme,
				"show_log_in" => "true",
				"L_LOGIN" => $lang['Login'],
				"L_USERNAME" => $lang['Username'],
				"L_PASSWORD" => $lang['Password'],
				"L_REMEMBER_ME" => $lang['Remember_me'])
		);
	}
	$smarty->display("$def_theme/login.tpl");
}

function gzip_PrintFourChars($Val) {
	for ($i = 0; $i < 4; $i ++) {
		$return .= chr($Val % 256);
		$Val = floor($Val / 256);
	}
	return $return;
}

// Note: All backup fuctions are from phpBB2 http://www.phpbb.com
//
// This function is used for grabbing the sequences for postgres...
//
function pg_get_sequences($crlf, $backup_type)
{
	global $db;

	$get_seq_sql = "SELECT relname FROM pg_class WHERE NOT relname ~ 'pg_.*'
		AND relkind = 'S' ORDER BY relname";

	$seq = $db->query($get_seq_sql);

	if( !$num_seq = $seq->numRows() )
	{

		$return_val = "# No Sequences Found $crlf";

	}
	else
	{
		$return_val = "# Sequences $crlf";
		$i_seq = 0;

		while($i_seq < $num_seq)
		{
			$row = $seq->fetchRow(DB_FETCHMODE_ASSOC);
			$sequence = $row['relname'];

			$get_props_sql = "SELECT * FROM $sequence";
			$seq_props = $db->query($get_props_sql);

			if($seq_props->numRows() > 0)
			{

				$row1 = $seq_props->fetchRow();

				if($backup_type == 'structure')
				{
					$row['last_value'] = 1;
				}

				$return_val .= "CREATE SEQUENCE $sequence start " . $row['last_value'] . ' increment ' . $row['increment_by'] . ' maxvalue ' . $row['max_value'] . ' minvalue ' . $row['min_value'] . ' cache ' . $row['cache_value'] . "; $crlf";

			}  // End if numrows > 0

			if(($row['last_value'] > 1) && ($backup_type != 'structure'))
			{
				$return_val .= "SELECT NEXTVALE('$sequence'); $crlf";
				unset($row['last_value']);
			}

			$i_seq++;

		} // End while..

	} // End else...

	return $returnval;

} // End function...


function get_table_def_postgresql($table, $crlf)
{
	global $drop, $db;

	$schema_create = "";
	//
	// Get a listing of the fields, with their associated types, etc.
	//

	$field_query = "SELECT a.attnum, a.attname AS field, t.typname as type, a.attlen AS length, a.atttypmod as lengthvar, a.attnotnull as notnull
		FROM pg_class c, pg_attribute a, pg_type t
		WHERE c.relname = '$table'
			AND a.attnum > 0
			AND a.attrelid = c.oid
			AND a.atttypid = t.oid
		ORDER BY a.attnum";
	$result = $db->query($field_query);

	if(!$result)
	{
		die("Backup Failed");
	} // end if..
	
	$drop = 1;
	if ($drop == 1)
	{
		$schema_create .= "DROP TABLE $table;$crlf";
	} // end if

	//
	// Ok now we actually start building the SQL statements to restore the tables
	//

	$schema_create .= "CREATE TABLE $table($crlf";

	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		//
		// Get the data from the table
		//
		$sql_get_default = "SELECT d.adsrc AS rowdefault
			FROM pg_attrdef d, pg_class c
			WHERE (c.relname = '$table')
				AND (c.oid = d.adrelid)
				AND d.adnum = " . $row['attnum'];
		$def_res = $db->query($sql_get_default);

		if (!$def_res)
		{
			unset($row['rowdefault']);
		}
		else
		{
			$row['rowdefault'] = @pg_result($def_res, 0, 'rowdefault');
		}

		if ($row['type'] == 'bpchar')
		{
			// Internally stored as bpchar, but isn't accepted in a CREATE TABLE statement.
			$row['type'] = 'char';
		}

		$schema_create .= '	' . $row['field'] . ' ' . $row['type'];

		if (eregi('char', $row['type']))
		{
			if ($row['lengthvar'] > 0)
			{
				$schema_create .= '(' . ($row['lengthvar'] -4) . ')';
			}
		}

		if (eregi('numeric', $row['type']))
		{
			$schema_create .= '(';
			$schema_create .= sprintf("%s,%s", (($row['lengthvar'] >> 16) & 0xffff), (($row['lengthvar'] - 4) & 0xffff));
			$schema_create .= ')';
		}

		if (!empty($row['rowdefault']))
		{
			$schema_create .= ' DEFAULT ' . $row['rowdefault'];
		}

		if ($row['notnull'] == 't')
		{
			$schema_create .= ' NOT NULL';
		}

		$schema_create .= ",$crlf";

	}
	//
	// Get the listing of primary keys.
	//

	$sql_pri_keys = "SELECT ic.relname AS index_name, bc.relname AS tab_name, ta.attname AS column_name, i.indisunique AS unique_key, i.indisprimary AS primary_key
		FROM pg_class bc, pg_class ic, pg_index i, pg_attribute ta, pg_attribute ia
		WHERE (bc.oid = i.indrelid)
			AND (ic.oid = i.indexrelid)
			AND (ia.attrelid = i.indexrelid)
			AND	(ta.attrelid = bc.oid)
			AND (bc.relname = '$table')
			AND (ta.attrelid = i.indrelid)
			AND (ta.attnum = i.indkey[ia.attnum-1])
		ORDER BY index_name, tab_name, column_name ";
	$result = $db->query($sql_pri_keys);

	if(!$result)
	{
		die("Backup Failed");
	}

	while ( $row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		if ($row['primary_key'] == 't')
		{
			if (!empty($primary_key))
			{
				$primary_key .= ', ';
			}

			$primary_key .= $row['column_name'];
			$primary_key_name = $row['index_name'];

		}
		else
		{
			//
			// We have to store this all this info because it is possible to have a multi-column key...
			// we can loop through it again and build the statement
			//
			$index_rows[$row['index_name']]['table'] = $table;
			$index_rows[$row['index_name']]['unique'] = ($row['unique_key'] == 't') ? ' UNIQUE ' : '';
			$index_rows[$row['index_name']]['column_names'] .= $row['column_name'] . ', ';
		}
	}

	if (!empty($index_rows))
	{
		while(list($idx_name, $props) = each($index_rows))
		{
			$props['column_names'] = ereg_replace(", $", "" , $props['column_names']);
			$index_create .= 'CREATE ' . $props['unique'] . " INDEX $idx_name ON $table (" . $props['column_names'] . ");$crlf";
		}
	}

	if (!empty($primary_key))
	{
		$schema_create .= "	CONSTRAINT $primary_key_name PRIMARY KEY ($primary_key),$crlf";
	}

	//
	// Generate constraint clauses for CHECK constraints
	//
	$sql_checks = "SELECT rcname as index_name, rcsrc
		FROM pg_relcheck, pg_class bc
		WHERE rcrelid = bc.oid
			AND bc.relname = '$table'
			AND NOT EXISTS (
				SELECT *
					FROM pg_relcheck as c, pg_inherits as i
					WHERE i.inhrelid = pg_relcheck.rcrelid
						AND c.rcname = pg_relcheck.rcname
						AND c.rcsrc = pg_relcheck.rcsrc
						AND c.rcrelid = i.inhparent
			)";
	$result = $db->query($sql_checks);

	if (!$result)
	{
		die("Backup Failed");
	}

	//
	// Add the constraints to the sql file.
	//
	while ($row = $result->fetchRow())
	{
		$schema_create .= '	CONSTRAINT ' . $row['index_name'] . ' CHECK ' . $row['rcsrc'] . ",$crlf";
	}

	$schema_create = ereg_replace(',' . $crlf . '$', '', $schema_create);
	$index_create = ereg_replace(',' . $crlf . '$', '', $index_create);

	$schema_create .= "$crlf);$crlf";

	if (!empty($index_create))
	{
		$schema_create .= $index_create;
	}

	//
	// Ok now we've built all the sql return it to the calling function.
	//
	return (stripslashes($schema_create));

}

function get_table_content_postgresql($table, $handler)
{
	global $db;

	//
	// Grab all of the data from current table.
	//

	$result = $db->query("SELECT * FROM $table");

	if (!$result)
	{
		die("Backup Failed");
	}

	$i_num_fields = $result->numCols();

	$info = $db->tableInfo($result);

	for ($i = 0; $i < $i_num_fields; $i++)
	{
		$aryType[] = $info[$i][type];
		$aryName[] = $info[$i][name];
	}

	$iRec = 0;

	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
	{
		unset($schema_vals);
		unset($schema_fields);
		unset($schema_insert);
		//
		// Build the SQL statement to recreate the data.
		//
		for($i = 0; $i < $i_num_fields; $i++)
		{
			$strVal = $row[$aryName[$i]];
			if (eregi("char|text|bool", $aryType[$i]))
			{
				$strQuote = "'";
				$strEmpty = "";
				$strVal = addslashes($strVal);
			}
			elseif (eregi("date|timestamp", $aryType[$i]))
			{
				if (empty($strVal))
				{
					$strQuote = "";
				}
				else
				{
					$strQuote = "'";
				}
			}
			else
			{
				$strQuote = "";
				$strEmpty = "NULL";
			}

			if (empty($strVal) && $strVal != "0")
			{
				$strVal = $strEmpty;
			}

			$schema_vals .= " $strQuote$strVal$strQuote,";
			$schema_fields .= " $aryName[$i],";

		}

		$schema_vals = ereg_replace(",$", "", $schema_vals);
		$schema_vals = ereg_replace("^ ", "", $schema_vals);
		$schema_fields = ereg_replace(",$", "", $schema_fields);
		$schema_fields = ereg_replace("^ ", "", $schema_fields);

		//
		// Take the ordered fields and their associated data and build it
		// into a valid sql statement to recreate that field in the data.
		//
		$schema_insert = "INSERT INTO $table ($schema_fields) VALUES($schema_vals);";

		$handler(trim($schema_insert));
	}

	return(true);

}// end function get_table_content_postgres...

function output_table_content($content)
{
	global $tempfile;

	//fwrite($tempfile, $content . "\n");
	//$backup_sql .= $content . "\n";
	echo $content ."\n";
	return;
}

function get_table_structure($table, $crlf, $drop) {
	$schema_create = "";
	$field_query = "SHOW FIELDS FROM $table";
	$key_query = "SHOW KEYS FROM $table";
	//
	// If the user has selected to drop existing tables when doing a restore.
	// Then we add the statement to drop the tables....
	//
	if ($drop == 1) {
		$schema_create .= "DROP TABLE IF EXISTS $table;$crlf";
	}
	$schema_create .= "CREATE TABLE $table($crlf";
	//
	// Ok lets grab the fields...
	//
	$result = mysql_query($field_query) or die(mysql_error());
	if (!$result) {
		message_die(GENERAL_ERROR, "Failed in get_table_def (show fields)", "", __LINE__, __FILE__, $field_query);
	}
	while ($row = mysql_fetch_row($result)) {
		$schema_create .= ' ' . $row['0'] . ' ' . $row['1'];
		if (!empty($row['4'])) {
			$schema_create .= ' DEFAULT \'' . $row['4'] . '\'';
		}
		if ($row['2'] != "YES") {
			$schema_create .= ' NOT NULL';
		}
		if ($row['5'] != "") {
			$schema_create .= ' ' . $row['5'];
		}
		$schema_create .= ",$crlf";
	}
	//
	// Drop the last ',$crlf' off ;)
	//
	$schema_create = ereg_replace(',' . $crlf . '$', "", $schema_create);
	//
	// Get any Indexed fields from the database...
	//
	$result = mysql_query($key_query) or die(mysql_error());
	if (!$result) {
		message_die(GENERAL_ERROR, "FAILED IN get_table_def (show keys)", "", __LINE__, __FILE__, $key_query);
	}
	while ($row = mysql_fetch_row($result)) {
		$kname = $row['2'];
		if (($kname != 'PRIMARY') && ($row['Non_unique'] == 0)) {
			$kname = "UNIQUE|$kname";
		}
		if (!is_array($index[$kname])) {
			$index[$kname] = array();
		}
		$index[$kname][] = $row['4'];
	}
	while (list($x, $columns) = @each($index)) {
		$schema_create .= ", $crlf";
		if ($x == 'PRIMARY') {
			$schema_create .= ' PRIMARY KEY (' . implode($columns, ', ') . ')';
		} elseif (substr($x, 0, 6) == 'UNIQUE') {
			$schema_create .= ' UNIQUE ' . substr($x, 7) . ' (' . implode($columns, ', ') . ')';
		} else {
			$schema_create .= " KEY $x (" . implode($columns, ', ') . ')';
		}
	}
	$schema_create .= "$crlf);";
	if (get_magic_quotes_runtime()) {
		return(stripslashes($schema_create));
	} else {
		return($schema_create);
	}
} // End get_table_structure
function get_table_content($table) {
	// Grab the data from the table.
	if (!($result = mysql_query("SELECT * FROM $table"))) {
		message_die(GENERAL_ERROR, "Failed in get_table_content (select *)", "", __LINE__, __FILE__, "SELECT * FROM $table");
	}
	// Loop through the resulting rows and build the sql statement.
	if ($row = mysql_fetch_row($result)) {
		output_table_content("\n#\n# Table Data for $table\n#\n");
		$field_names = array();
		// Grab the list of field names.
		$num_fields = mysql_num_fields($result);
		$table_list = '(';
		for ($j = 0; $j < $num_fields; $j++) {
			$field_names[$j] = mysql_field_name($result, $j);
			$table_list .= (($j > 0) ? ', ' : '') . $field_names[$j];
		}
		$table_list .= ')';
		do {
			// Start building the SQL statement.
			$schema_insert = "INSERT INTO $table $table_list VALUES(";
			// Loop through the rows and fill in data for each column
			for ($j = 0; $j < $num_fields; $j++) {
				$schema_insert .= ($j > 0) ? ', ' :
				'';
				if (!isset($row[$j])) {
					//
					// If there is no data for the column set it to null.
					// There was a problem here with an extra space causing the
					// sql file not to reimport if the last column was null in
					// any table.  Should be fixed now :) JLH
					//
					$schema_insert .= 'NULL';
				} elseif ($row[$j] != '') {
					$schema_insert .= '\'' . addslashes($row[$j]) . '\'';
				} else {
					$schema_insert .= '\'\'';
				}
			}
			$schema_insert .= ');';
			// Go ahead and send the insert statement to the handler function.
			output_table_content(trim($schema_insert));
		}
		while ($row = mysql_fetch_row($result));
		mysql_free_result($result);
	}
	return(true);
}

// End Backup Functions List

/*
 * Returns true if the username has been taken
 * by another user, false otherwise.
 */
function usernameTaken($username) {
	global $db;

	if (!get_magic_quotes_gpc()) {
		$username = addslashes($username);
	}
	$sql = "SELECT username FROM " . TABLE_PRE . "users WHERE username = '$username'";
	$result = $db->query($sql);
	$rows = $result->numRows();
	$result->free();
	return ($rows > 0);
}

function emailTaken($email) {
	global $db;

	$sql = "SELECT uid FROM " . TABLE_PRE . "users WHERE email = '$email'";
	$result = $db->query($sql);
	$rows = $result->numRows();
	$result->free();
	return ($rows > 0);
}

function myLoginCallback($username,$a)
{
	setcookie("username", $username, time()+60*60*24*30,'','');
} // myLoginCallBack

function myLogoutCallback()
{
	setcookie("username", '', time()-3600);
} // myLogoutCallBack 

function sendAuthEmail($user)
{
	global $db, $def_theme, $def_language, $admin_email;

	include('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');

	$sql = "SELECT uid, email FROM " . TABLE_PRE . "users WHERE username = '$user'";
	$result = $db->query($sql);
	$row = $result->fetchRow(DB_FETCHMODE_ORDERED);
	$result->free();

	$authcode = md5(uniqid(rand(), true));
	$userid = $row[0];
	$user_email = $row[1];
	
	$sql = "INSERT INTO " . TABLE_PRE . "auth (userid, authcode) VALUES ('$userid', '$authcode')";
	$db->query($sql);
	
	$path = "http://{$_SERVER[HTTP_HOST]}{$_SERVER[REQUEST_URI]}";
	$self=basename($_SERVER[PHP_SELF]); 
	$path = str_replace($self, "", $path);
	
	$message = sprintf($lang['Email_validation'], $path, "<a href=\"" . $path . "validate.php?authcode=" . $authcode . "\">", "" . $path . "validate.php?authcode=" . $authcode . "", "</a>");
	$title = $lang['Validation_email_title'];
	
	ini_set(sendmail_from, $admin_email);
	
        mail($email[0], $title, $message,
                "From: ${admin_email}\n" .
                "Content-type: text/html\n" .
                "X-Mailer: PHP/" . phpversion());
	ini_restore(sendmail_from);

} // sendAuthEmail


function resendAuthEmail($uid)
{
	global $db, $def_theme, $def_language, $admin_email;

	include('./language/lang_' . $def_language . '/lang_' . $def_language . '.php');
	
	$sql = "SELECT email FROM " . TABLE_PRE . "users WHERE uid = '$uid'";
	$result = $db->query($sql);
	$email = $result->fetchRow(DB_FETCHMODE_ORDERED);
	$result->free();
	
	$sql = "SELECT authcode FROM " . TABLE_PRE . "auth WHERE userid = '$uid'";
	$result = $db->query($sql);
	$authcode = $result->fetchRow(DB_FETCHMODE_ORDERED);
	$result->free();
	
	/* Used to get the Full path of the site that its running on */
	$path = "http://{$_SERVER[HTTP_HOST]}{$_SERVER[REQUEST_URI]}";
	$self=basename($_SERVER[PHP_SELF]);
	$url = parse_url($path);
	$path = str_replace($self, "", $path);
	$path = str_replace($url[query], "", $path);
	$path = str_replace("?", "", $path);
	
	$title = $lang['Validation_email_title'];
	$message = sprintf($lang['Resend_email_validation'], $path, "<a href=\"" . $url[scheme] . "://" . $url[host] . "" . $url[path] . "?authcode=" . $authcode[0] . "\">", "" . $url[scheme] . "://" . $url[host] . "" . $url[path] . "?authcode=" . $authcode[0] . "", "</a>");
	
	ini_set(sendmail_from, $admin_email);
	
	mail($email[0], $title, $message,
		"From: ${admin_email}\n" .
		"Content-type: text/html\n" .
		"X-Mailer: PHP/" . phpversion());
	ini_restore(sendmail_from);
	
} // resendAuthEmail

function mail_mash($addy) {

   $addy = 'mailto:'.$addy;
   for($i=0;$i<strlen($addy);$i++){ $letters[]=$addy[$i]; }
  
   while (list($key, $val) = each($letters)) {
       $r = rand(0,20);
       if ($r > 9) { $letters[$key] = '&#'.ord($letters[$key]).';';}
   }
  
$mashed_email_addy = implode('', $letters);
return $mashed_email_addy;

}
	
?>
