<?php
//  Copyright (C) 2004-2005  Drew Withers

//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,



$lang_dir = "../language/";

$handle = opendir($lang_dir);
while($file = readdir($handle)) {
	if ($file=='.' || $file=='..'){
	
	}else{
      	$completepath = "$lang_dir/$file";
            if (is_dir($completepath)) {
			$handle2 = opendir($completepath);
			while($file2 = readdir($handle2)){
				if ($file2 == '.' || $file2 == '..'){
				
				}else{
					$completepath="$completepath/$file2";
					if(is_dir($completepath)){
					
					}else{
						$language = substr($file2, 0, -4);
						$language = strstr($language, '_');
						$language = str_replace("_", "", $language);
						$languages[] = $language;
						$display = ucfirst($language);
						$options .= "<option value=\"$language\">$display</option>";
					}
				}
			}
            } else {
			$language = substr($file, 0, -4);
			$language = strstr($language, '_');
			$language = str_replace("_", "", $language);
			$languages[] = $language;
			$display = ucfirst($language);
			$options .= "<option value=\"$language\">$display</option>";
		}
	}
}

function main_page($path, $lang_type, $options){

require_once($path);

?>

<!DOCTYPE html 
	PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title><?php echo $lang['Installer_title']; ?></title>
  <link rel="stylesheet" type="text/css" href="style.css"/>
</head>
<body style="background-color:#EEEEEE;">
<div class="centered">
<script src="../scripts/forms.js" type="text/javascript"></script>
<form name="form1" action="install.php?language=<?php echo $lang_type; ?>" method="post" onsubmit="return validate_install(this)">
<table border="1" cellpadding="0" cellspacing="0" width="85%" style="background:#FFFFFF;">
  <tr>
    <td align="center" colspan="2">
	<br/><h1><?php echo $lang['Installer_title']; ?></h1><br/><br/>
	<p><?php echo $lang['Welcome_message']; ?></p><br/><br/>
    </td>
  </tr>
  <tr>
    <th colspan="2" align="left" style="background:url(img/cellpic1.gif);">
	<p style="font-size:1.0em;"><?php echo $lang['Installation_information']; ?></p>
    </th>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;"align="right" width="35%">
	<p><?php echo $lang['Database_type']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><select name="database_type" size="1">
	<option label="selectdatabase" value="selectdatabase" selected="selected"><?php echo $lang['Select_database_type']; ?></option>
	<option label="mysql" value="mysql"><?php echo $lang['MySQL']; ?></option>
	<option label="postgresql" value="pgsql"><?php echo $lang['PostgreSQL']; ?></option>
	</select></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;"align="right" width="35%">
	<p><?php echo $lang['Installation_type']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><select name="install_type" onchange="ldMenu(this.selectedIndex);" size="1">
	<option label="selectinstall" value="selectinstall" selected="selected"><?php echo $lang['Select_install_type']; ?></option>
	<option label="install" value="install"><?php echo $lang['New_installation']; ?></option>
	<option label="upgrade" value="upgrade"><?php echo $lang['Upgrade']; ?></option>
	</select></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;"align="right" width="35%">
	<p><?php echo $lang['Password_crypt_type']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><select name="crypt_type">
	<option label="selectcrypt" value="selectcrypt" selected="selected"><?php echo $lang['Select_crypt_type']; ?></option>
	</select></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;"align="right" width="35%">
	<p><?php echo $lang['Language_type']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><select name="language_type" size="1">
	<option label="selectlanguage" value="selectlanguage" selected="selected">
	<?php echo $lang['Select_language_type']; ?></option>
	<?php echo $options; ?>
	</select></p>
    </td>
  </tr>
  <tr>
    <td colspan="2" align="left" style="background:url(img/cellpic1.gif);">
	<p style="font-size:1.0em;"><strong><?php echo $lang['Database_information']; ?></strong></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Database_hostname']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input name="db_host" maxlength="30" value="localhost" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Database_name']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input name="db_name" maxlength="30" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Database_username']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input name="db_user" maxlength="30" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Database_password']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input type="password" name="db_pass" maxlength="30" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Prefix_for_tables']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input name="table_pre" maxlength="30" value="<?php echo $lang['journalness_']; ?>" /></p>
    </td>
  </tr>
  <tr>
    <th colspan="2" align="left" style="background:url(img/cellpic1.gif);">
	<p style="font-size:1.0em;"><?php echo $lang['Administrator_information']; ?></p>
    </th>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Administrator_email']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left"><?php
	echo "<p><input name=\"admin_email\" maxlength=\"50\" value=\"admin@" . $_SERVER[SERVER_NAME]. "\" /></p>";?>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Administrator_username']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input name="admin_name" maxlength="30" value="admin" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Admin_password']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input type="password" name="admin_pass" maxlength="30" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Confirm_admin_password']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input type="password" name="admin_pass_confirm" maxlength="30" /></p>
    </td>
  </tr>
  <tr>
    <td style="border-color:#FFFFFF;" align="right" width="35%">
	<p><?php echo $lang['Require_email_validation']; ?></p>
    </td>
    <td style="border-color:#FFFFFF;" align="left">
	<p><input type="radio" name="validation" value="yes"/><?php echo $lang['Yes']; ?> <input type="radio" name="validation" value="no" checked /><?php echo $lang['No']; ?></p>
    </td>
  </tr>
  <tr>
    <td colspan="2" align="center" style="background:url(img/cellpic1.gif); height:30px;">
	<input type="submit" name="submit" value="<?php echo $lang['Start_installation']; ?>">
    </td>
  </tr>
</table>
</form>
</div>
</body>
</html>

<?php

}

if (@file_exists('./../config.php'))
{
	$root_path = './../';
	include($root_path.'config.php');
}

if (defined("INSTALLED"))
{
	header("Location: $root_path" . "index.php");
}

$submit = $_POST['submit'];
$lang_type = $_GET['language'];

if(isset($submit)){

	if(isset($lang_type)){
		$path = realpath("../language/lang_" . $lang_type . "/lang_" . $lang_type . ".php");
		require_once($path);
	}

	/* Get Information required for install */
	$install_type = $_POST['install_type'];
	$crypt_type = $_POST['crypt_type'];
	$db_host = $_POST['db_host'];
	$db_name = $_POST['db_name'];
	$db_user = $_POST['db_user'];
	$db_pass = $_POST['db_pass'];
	$table_pre = $_POST['table_pre'];
	$admin_name = $_POST['admin_name'];
	$admin_pass = $_POST['admin_pass'];
	$admin_email = $_POST['admin_email'];
	$validation = $_POST['validation'];
	$dbms = $_POST['database_type'];
	$def_language = $_POST['language_type'];
	$upload_type = "files";

?>
<!DOCTYPE html 
	PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title><?php echo $lang['Installer_title']; ?></title>
  <link rel="stylesheet" type="text/css" href="style.css"/>
</head>
<body style="background-color:#EEEEEE;">
<div class="centered">
<table border="1" cellpadding="0" cellspacing="0" width="85%" style="background:#FFFFFF;">
  <tr>
    <td align="center" colspan="2">
<?php

chdir("../");
$path = getcwd();
$path .= "/includes/";
ini_set("include_path", $path . PATH_SEPARATOR . ini_get("include_path"));

require_once 'DB.php';
//PEAR::setErrorHandling(PEAR_ERROR_DIE);
//error_reporting (E_ALL ^ E_NOTICE);
// this function will handle all reported errors
function my_error_handler ($errno, $errstr, $errfile, $errline) {
    echo "In $errfile, line: $errline\n<br>$errstr";
}
//set_error_handler ('my_error_handler');
$dsn = "".$dbms."://".$db_user.":".$db_pass."@";
if($db_host != 'localhost'){
	$dsn .= "".$db_host."";
}
$dsn .= "/".$db_name."";
$db = DB::connect($dsn);
chdir("install");

if($install_type == "install"){	

	// Modified from phpBB2's installer script.
	$dbms_schema = 'schemas/' . $dbms . '_schema.sql';
	$sql = @fread(@fopen($dbms_schema, 'r'), @filesize($dbms_schema));
	$sql = preg_replace('/journalness_/', $table_pre, $sql);

	$sql = split_sql_file($sql, ";");

	for ($i = 0; $i < sizeof($sql); $i++)
	{
		if (trim($sql[$i]) != '')
		{
			$result = $db->query($sql[$i]);
		}
	}

	$phpver = phpversion();

	if(extension_loaded("mhash") && $crypt_type == "sha1"){
		$admin_pass .= "7b949c8716";  // A very basic salting of the password
		$passhash = bin2hex(mhash(MHASH_SHA1, $admin_pass));
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$passhash', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}elseif($phpver >= "4.3.0" && $crypt_type == "sha1"){
		$admin_pass .= "7b949c8716";  // A very basic salting of the password
		$sha1pass = sha1($admin_pass);
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$sha1pass', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}elseif($crypt_type == "sha1"){
		die("Please load the MHASH extension or install PHP >= 4.3.0 to use SHA-1");
	}

	if(extension_loaded("mhash") && $crypt_type == "md5"){
		$admin_pass .= "7b949c8716";  // A very basic salting of the password
		$passhash = bin2hex(mhash(MHASH_MD5, $admin_pass));
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$passhash', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}elseif($crypt_type == "md5"){
		$admin_pass .= "7b949c8716";  // A very basic salting of the password
		$passhash = md5($admin_pass);
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$passhash', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}

	if($crypt_type == "crypt"){
		$admin_salt = crypt($admin_pass, $admin_pass);
		$passhash = crypt($admin_pass, $admin_salt);
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$passhash', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}

	if($crypt_type == "none"){
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, isadmin, def_user_lang, def_user_theme) VALUES ('$admin_name', '$admin_pass', '$admin_email', '1', '1', '1', '$def_language', 'classic')";
		$db->query($sql);
	}

	$dbms_data = 'schemas/' . $dbms . '_data.sql';
	$ip = getenv("REMOTE_ADDR");
	$entry_time = date("Y-m-d H:i:s");
	$sql = @fread(@fopen($dbms_data, 'r'), @filesize($dbms_data));

	$sql = preg_replace('/journalness_/', $table_pre, $sql);
	$sql = preg_replace('/\$entry_time/', $entry_time, $sql);
	$sql = preg_replace('/\$poster/', $admin_name, $sql);
	$sql = preg_replace('/\$fake_password/', md5(uniqid(rand(), true)), $sql);
	$sql = preg_replace('/\$ip/', $ip, $sql);
	$sql = preg_replace('/\$crypt_type/', $crypt_type, $sql);
	$sql = preg_replace('/\$def_language/', $def_language, $sql);
	$sql = preg_replace('/\$validation/', $validation, $sql);

	$sql = split_sql_file($sql, ";");

	for ($i = 0; $i < sizeof($sql); $i++)
	{
		if (trim($sql[$i]) != '')
		{
			$result = $db->query($sql[$i]);
		}
	}

}elseif($install_type == "upgrade"){

	$sql = "SELECT * FROM " . $table_pre . "users where username = '$admin_name'";
	$result = $db->query($sql);
	if (DB::isError($result)) {
		backup();
		die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
	}
	$row = $result->fetchRow();

	if($row){

	}else{
		die("The admin account you specified does not exist in your database.");
	}

	$phpver = phpversion();
	$sql = "SELECT password FROM " . $table_pre . "users WHERE username = '$admin_name'";
	$query = $db->query($sql);
	if (DB::isError($query)) {
		backup();
		die ("" . $query->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
	}
	$result = $query->fetchRow(DB_FETCHMODE_ORDERED);

	if(extension_loaded("mhash")){
		$admin_pass_sha1 = $admin_pass;
		$admin_pass_sha1 .= "7b949c8716";  // A very basic salting of the password
		$passhash = bin2hex(mhash(MHASH_SHA1, $admin_pass_sha1));
		if($result[0] == $passhash){
			$crypt_type = "sha1";
		}
	}elseif($phpver >= "4.3.0"){
		$admin_pass_sha1 = $admin_pass;
		$admin_pass_sha1 .= "7b949c8716";  // A very basic salting of the password
		$sha1pass = sha1($admin_pass_sha1);
		if($result[0] == $sha1pass){
			$crypt_type = "sha1";
		}
	}elseif( (!(extension_loaded("mhash"))) && (!($phpver >= "4.3.0"))){
		die("Please load the MHASH extension or install PHP >= 4.3.0 to use SHA-1");
	}

	if(extension_loaded("mhash")){
		$admin_pass_md5 = $admin_pass;
		$admin_pass_md5 .= "7b949c8716";  // A very basic salting of the password
		$passhash = bin2hex(mhash(MHASH_MD5, $admin_pass_md5));
		if($result[0] == $passhash){
			$crypt_type = "md5";
		}
	}elseif(!(extension_loaded("mhash"))){
		$admin_pass_md5 = $admin_pass;
		$admin_pass_md5 .= "7b949c8716";  // A very basic salting of the password
		$passhash = md5($admin_pass_md5);
		if($result[0] == $passhash){
			$crypt_type = "md5";
		}

	}

	$admin_salt = crypt($admin_pass, $admin_pass);
	$admin_pass_crypt = crypt($admin_pass, $admin_salt);
	$passhash = $admin_pass_crypt;
	if($result[0] == $passhash){
		$crypt_type = "crypt";
	}

	if($result[0] == $admin_pass){
		$crypt_type = "none";
	}

	if(!$crypt_type){
		die($lang[No_pass_match]);
	}

	if($dbms == "pgsql"){

		$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('crypt_type', '$crypt_type')";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}
		$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('def_theme', 'classic')";
		$result = $db->query($sql);
		if (DB::isError($result)) {
            	backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}
		$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('anon_comment', 'yes')";
		$result = $db->query($sql);
		if (DB::isError($result)) {
                  backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
            }
		$sql = "UPDATE " . $table_pre . "config SET value = '3.5.4' WHERE name = 'version'";
                 $result = $db->query($sql);
                  if (DB::isError($result)) {
                     backup();
                    die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
																                           }
		/* Grab all data from the users table and put into an Array */
		$sql = "SELECT * FROM " . $table_pre . "users";
		if($result = $db->query($sql)){
			$numrows = $result->numRows();
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$userdata[] = $row;
			}
		}

		$sql = "DROP TABLE " . $table_pre . "users";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		$sql="CREATE TABLE " . $table_pre . "users(
			uid int(10) NOT NULL AUTO_INCREMENT,
			username varchar(40),
			password varchar(40),
			email varchar(255) NOT NULL,
			email_public TINYINT(1) UNSIGNED NOT NULL,
			verified TINYINT(1) UNSIGNED NOT NULL,
			isadmin TINYINT(3) UNSIGNED NULL,
			def_user_lang varchar(255) NOT NULL,
			realname varchar(100),
			age int(3),
			sex varchar(1),
			icq varchar(15),
			aim varchar(255),
			yim varchar(255),
			msn varchar(255),
			website varchar(100),
			location varchar(100),
			clip text,
			sig text,
			def_user_theme varchar(255) NOT NULL,
			PRIMARY KEY(uid),
			UNIQUE KEY email (email)
		)";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		/* Loop through array and insert data back into the database */
		for($i = 0; $i < $numrows; $i++){
			extract($userdata[$i]);
			if(empty($age)){
				$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, def_user_lang, realname, age, sex, icq, aim, yim, msn, website, location, def_user_theme) VALUES ('$username', '$password', '$email', '1', '1', '$def_language', '$realname', NULL, '$sex', '$icq', '$aim', '$yim', '$msn', '$website', '$location', 'classic')";
				$db->query($sql);
			}else{
				$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, def_user_lang, realname, age, sex, icq, aim, yim, msn, website, location, def_user_theme) VALUES ('$username', '$password', '$email', '1', '1', '$def_language', '$realname', '$age', '$sex', '$icq', '$aim', '$yim', '$msn', '$website', '$location', 'classic')";
				$db->query($sql);
			}
		}

		//Nothing to upgrade in this version

	}elseif($dbms == "mysql"){

		$sql="ALTER TABLE " . $table_pre . "journalness CHANGE user poster VARCHAR( 30 ) NULL";
		$db->query($sql);

		$sql = "SELECT * FROM " . $table_pre ."auth LIMIT 0,1";
		$check = $db->query($sql);

		if ($check){
			
		}else{
			$sql="DROP TABLE IF EXISTS " . $table_pre . "auth";
			$db->query($sql);
		
			$sql="CREATE TABLE " . $table_pre . "auth(
				userid TINYINT UNSIGNED NOT NULL,
				authcode VARCHAR(32)
			)";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
		}


		$sql = "SELECT * FROM " . $table_pre ."config LIMIT 0,1";
		$check = $db->query($sql);

		if ($check){
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('def_theme', 'classic')";	
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();	
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}	
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('anon_comment', 'yes')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "UPDATE " . $table_pre . "config SET value = '3.5.4' WHERE name = 'version'";
			$result = $db->query($sql);
			 if (DB::isError($result)) {
			         backup();
				 die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
		}else{

			$sql="DROP TABLE IF EXISTS " . $table_pre . "config";
			$db->query($sql);
		
			$sql="CREATE TABLE " . $table_pre . "config(
					name varchar(255) NOT NULL,
					value varchar(255) NOT NULL,
					PRIMARY KEY (name)
			)";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}

					$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('version', '3.5.4')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('journaltitle', 'Journalness')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('journaltype', '1')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('newest_entries', '3')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('def_language', '$def_language')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('uploads', 'files')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('validation', '$validation')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('crypt_type', '$crypt_type')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('def_theme', 'classic')";	
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();	
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}	
			$sql = "INSERT INTO " . $table_pre . "config (name, value) VALUES ('anon_comment', 'yes')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}

		}

		
		$sql = "SELECT * FROM " . $table_pre ."links LIMIT 0,1";
		$check = $db->query($sql);

		if ($check){
			
		}else{
			$sql="DROP TABLE IF EXISTS " . $table_pre . "links";
			$db->query($sql);

			$sql="CREATE TABLE " . $table_pre . "links(
				linkid int(8) NOT NULL auto_increment,
				name VARCHAR(255) NOT NULL,
				value VARCHAR(255) NULL,
				iscategory TINYINT UNSIGNED NULL,
				incategory int(8) NULL,
				location int(8) NULL,
				visible TINYINT UNSIGNED NULL,
				PRIMARY KEY (linkid)
			)";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}

			$sql = "INSERT INTO " . $table_pre . "links (name, iscategory, location, visible) VALUES ('Links', '1', '1', '1')";
			$result = $db->query($sql);
			if (DB::isError($result)) {
				backup();
				die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
			}

		}

		/* Grab all data from the uploads table and put into an Array */
		$sql = "SELECT * FROM " . $table_pre . "uploads";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}else{
			$numrows = $result->numRows();
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$uploaddata[] = $row;
			}
		}

		$sql = "DROP TABLE IF EXISTS " . $table_pre . "uploads";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		$sql="CREATE TABLE " . $table_pre . "uploads(
			imageid int(10) NOT NULL auto_increment,
			image LONGTEXT,
			path varchar(255) NOT NULL,
			imagename varchar(255) NOT NULL,
			poster varchar(30), 
			PRIMARY KEY (imageid)
		)";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		/* Loop through array and insert data back into the database */
		for($i = 0; $i < $numrows; $i++){
			extract($uploaddata[$i]);
			$path2 = $path;
			$sql = "INSERT INTO " . $table_pre . "uploads (image, path, imagename, poster) VALUES ('$image', '$path2', '$imagename', '$user')";
			$db->query($sql);
		}


		/* Grab all data from the users table and put into an Array */
		$sql = "SELECT * FROM " . $table_pre . "users";
		if($result = $db->query($sql)){
			$numrows = $result->numRows();
			while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
				$userdata[] = $row;
			}
		}

		$sql = "DROP TABLE IF EXISTS " . $table_pre . "users";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		$sql="CREATE TABLE " . $table_pre . "users(
			uid int(10) NOT NULL AUTO_INCREMENT,
			username varchar(40),
			password varchar(40),
			email varchar(255) NOT NULL,
			email_public TINYINT(1) UNSIGNED NOT NULL,
			verified TINYINT(1) UNSIGNED NOT NULL,
			isadmin TINYINT(3) UNSIGNED NULL,
			def_user_lang varchar(255) NOT NULL,
			realname varchar(100),
			age int(3),
			sex varchar(1),
			icq varchar(15),
			aim varchar(255),
			yim varchar(255),
			msn varchar(255),
			website varchar(100),
			location varchar(100),
			clip text,
			sig text,
			def_user_theme varchar(255) NOT NULL,
			PRIMARY KEY(uid),
			UNIQUE KEY email (email)
		)";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

		/* Loop through array and insert data back into the database */
		for($i = 0; $i < $numrows; $i++){
			extract($userdata[$i]);
			if(empty($age)){
				$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, def_user_lang, realname, age, sex, icq, aim, yim, msn, website, location, def_user_theme) VALUES ('$username', '$password', '$email', '1', '1', '$def_language', '$realname', NULL, '$sex', '$icq', '$aim', '$yim', '$msn', '$website', '$location', 'classic')";
				$db->query($sql);
			}else{
				$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, def_user_lang, realname, age, sex, icq, aim, yim, msn, website, location, def_user_theme) VALUES ('$username', '$password', '$email', '1', '1', '$def_language', '$realname', '$age', '$sex', '$icq', '$aim', '$yim', '$msn', '$website', '$location', 'classic')";
				$db->query($sql);
			}
		}

		$sql = "UPDATE " . $table_pre . "users SET isadmin = '1' WHERE username = '$admin_name'";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}

                $sql = "UPDATE " . $table_pre . "users SET email = '$admin_email' WHERE isadmin = '1'";
		$result = $db->query($sql);
		if (DB::isError($result)) {
			backup();
			die ("" . $result->getMessage() . " -> An emergency backup of your data has been dumped into install/emergency_sql_dump.sql");
		}
																
		
		$fake_password = md5(uniqid(rand(), true));
		$sql = "INSERT INTO " . $table_pre . "users (username, password, email, email_public, verified, def_user_lang) VALUES ('Anonymous User', '$fake_password', 'anon_user', '0', '1', '$def_language')";
		$db->query($sql);

	}

}

?>
    </td>
  </tr>
  <tr>
    <td align="center" colspan="2">
	<br/><br/><p><?php echo $lang['Journalness_installed']; ?><br/><br/></p>
	<p><a href="../index.php"><?php echo $lang['Continue_installation']; ?></a></p><br/><br/>
    </td>
  <tr>
</table>
</body>
</html>

<?php

	// Write out the config file.
	$config_data .= '<?php'."\n\n";
	$config_data .= '// This file has been automatically generated by the Journalness install script. Do not edit!'."\n\n";
	$config_data .= 'define(\'DB_USERNAME\',\'' . $db_user . '\');' . "\n\n";
	$config_data .= 'define(\'DB_PASSWORD\',\'' . $db_pass . '\');' . "\n\n";
	$config_data .= 'define(\'DB_NAME\',\'' . $db_name . '\');' . "\n\n";
	$config_data .= 'define(\'DB_HOST\',\'' . $db_host . '\');' . "\n\n";
	$config_data .= 'define(\'TABLE_PRE\',\'' . $table_pre . '\');' . "\n\n";
	$config_data .= 'define(\'DBMS\',\'' . $dbms . '\');' . "\n\n";
	$config_data .= 'define(\'INSTALLED\', true);'."\n\n";
	$config_data .= '?' . '>';

	@umask(0111);

	$fp = @fopen('./../config.php', 'w');

	@fputs($fp, $config_data, strlen($config_data));

	@fclose($fp);

}else{

	$lang_type = $_GET['lang'];

	$count = count($languages);
	if($count > 1 && !$lang_type){
		echo "Choose the language to view installer with: <br/>";
		for($i = 0; $i < $count; $i++){
			echo "<a href=\"./install.php?lang=${languages[$i]}\">" . ucfirst($languages[$i]) . "</a><br/>";
		}
	}else{
		if(!$lang_type){
			$lang_type = "english";
		}
		$path = realpath("../language/lang_" . $lang_type . "/lang_" . $lang_type . ".php");

		main_page($path, $lang_type, $options);
	}


}

// From phpBB2
function split_sql_file($sql, $delimiter)
{
	// Split up our string into "possible" SQL statements.
	$tokens = explode($delimiter, $sql);

	// try to save mem.
	$sql = "";
	$output = array();
	
	// we don't actually care about the matches preg gives us.
	$matches = array();
	
	// this is faster than calling count($oktens) every time thru the loop.
	$token_count = count($tokens);
	for ($i = 0; $i < $token_count; $i++)
	{
		// Don't wanna add an empty string as the last thing in the array.
		if (($i != ($token_count - 1)) || (strlen($tokens[$i] > 0)))
		{
			// This is the total number of single quotes in the token.
			$total_quotes = preg_match_all("/'/", $tokens[$i], $matches);
			// Counts single quotes that are preceded by an odd number of backslashes, 
			// which means they're escaped quotes.
			$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$i], $matches);
			
			$unescaped_quotes = $total_quotes - $escaped_quotes;
			
			// If the number of unescaped quotes is even, then the delimiter did NOT occur inside a string literal.
			if (($unescaped_quotes % 2) == 0)
			{
				// It's a complete sql statement.
				$output[] = $tokens[$i];
				// save memory.
				$tokens[$i] = "";
			}
			else
			{
				// incomplete sql statement. keep adding tokens until we have a complete one.
				// $temp will hold what we have so far.
				$temp = $tokens[$i] . $delimiter;
				// save memory..
				$tokens[$i] = "";
				
				// Do we have a complete statement yet? 
				$complete_stmt = false;
				
				for ($j = $i + 1; (!$complete_stmt && ($j < $token_count)); $j++)
				{
					// This is the total number of single quotes in the token.
					$total_quotes = preg_match_all("/'/", $tokens[$j], $matches);
					// Counts single quotes that are preceded by an odd number of backslashes, 
					// which means they're escaped quotes.
					$escaped_quotes = preg_match_all("/(?<!\\\\)(\\\\\\\\)*\\\\'/", $tokens[$j], $matches);
			
					$unescaped_quotes = $total_quotes - $escaped_quotes;
					
					if (($unescaped_quotes % 2) == 1)
					{
						// odd number of unescaped quotes. In combination with the previous incomplete
						// statement(s), we now have a complete statement. (2 odds always make an even)
						$output[] = $temp . $tokens[$j];

						// save memory.
						$tokens[$j] = "";
						$temp = "";
						
						// exit the loop.
						$complete_stmt = true;
						// make sure the outer loop continues at the right point.
						$i = $j;
					}
					else
					{
						// even number of unescaped quotes. We still don't have a complete statement. 
						// (1 odd and 1 even always make an odd)
						$temp .= $tokens[$j] . $delimiter;
						// save memory.
						$tokens[$j] = "";
					}
					
				} // for..
			} // else
		}
	}

	return $output;
}

function backup()
{
	include('backup_functions.php');
	global $db_name, $dbms, $table_pre;

	$timestamp = date("Y-m-d_H-i-s");
	$tables = array('auth', 'comments', 'uploads', 'users', 'journalness', 'links', 'config');
	header("Pragma: no-cache");
	//$backup .= "#\n";
	//$backup .= "# Journalness Backup Script\n";
	//$backup .= "# Dump of tables for " . $db_name . "\n";
	//$backup .= "#\n# DATE : " . gmdate("d-m-Y H:i:s", time()) . " GMT\n";
	//$backup .= "#\n";
	for($i = 0; $i < count($tables); $i++) {
		$table_name = $tables[$i];
		$backup_type = "full";
		if($dbms == "pgsql"){
			//$backup .= "\n" . pg_get_sequences("\n", $backup_type);
		}
		if ($backup_type != 'data') {
			if($dbms == "mysql"){
				$drop = $_POST['drop'];
				$drop = "1";
				$check = mysql_query("SELECT * FROM " . $table_pre . "" . $table_name . " LIMIT 0,1");
				if($check){
					//$backup .= "#\n# Table structure for table: " . $table_pre . $table_name . "\n#\n";
					$backup .= get_table_structure($table_pre . $table_name, "\n", $drop) . "\n";
				}else{
				
				}
			}elseif($dbms == "pgsql"){
				//echo "#\n# Table structure for table: " . $table_pre . $table_name . "\n#\n";
				//echo get_table_def_postgresql($table_pre . $table_name, "\n") . "\n";
			}
		}
		if ($backup_type != 'structure') {
			if($dbms == "mysql"){
				$check = mysql_query("SELECT * FROM " . $table_pre . "" . $table_name . " LIMIT 0,1");
				if($check){
					//$backup .= "#\n# Table structure for table: " . $table_pre . $table_name . "\n#\n";
					$backup .= get_table_content($table_pre . $table_name);
				}else{
				
				}

			}elseif($dbms == "pgsql"){
				//echo "\n" . pg_get_sequences("\n", $backup_type);
				//get_table_content_postgresql($table_pre . $table_name, output_table_content);
			}
		}
	}

	$filename = "emergency_sql_dump.sql";

	if (is_writable($filename)) {
		if (!$handle = fopen($filename, 'w')) {
			echo "Cannot open file ($filename)";
			exit;
		}
		// Write $somecontent to our opened file.
		if (fwrite($handle, $backup) === FALSE) {
			echo "Cannot write to file ($filename)";
			exit;
		}
		
		fclose($handle);

	}

	return(true);

}


?>
