<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if ($a->checkAuth()) {
	$delete = $_POST['delete_x'];
	$delete2 = $_POST['delete2'];
	$edit = $_POST['edit_x'];
	$cancel = $_POST['cancel'];
	$eid = $_POST['eid'];
	$user = $_POST['user'];
	$cid = $_POST['cid'];
	$delete_comment = $_POST['delete_comment_x'];
	$edit_comment = $_POST['edit_comment_x'];
	$currentuser = $_POST['currentuser'];
	$confirm_delete_comment = $_POST['confirm_delete_comment'];
	if ($a->getUsername() == $user || $a->getUsername() == $admin_name) {
		if ($delete_comment || $edit_comment || $confirm_delete_comment) {
			if ($a->getUsername() == $admin_name) {
				if ($edit_comment) {
					$sql = "SELECT * FROM " . TABLE_PRE . "comments WHERE commentid=$cid";
					$result = $db->query($sql);
					$myrow = $result->fetchRow();
					$result->free();
					$comment = $myrow[5];
					$myrow[2] = str_replace('\"', '&#34;', $myrow[2]);
					$myrow[2] = str_replace('\'', '&#39;', $myrow[2]);
					$myrow[3] = formatDate($myrow[3]);
					$smarty->assign(array(
							"show_modify_comment" => "true",
							"commenttitle" => $myrow[2],
							"comment_time" => $myrow[3],
							"eid" => $eid,
							"user" => $user,
							"cid" => $cid,
							"comment" => $comment,
							"L_EDITING_COMMENT" => $lang['Editing_comment'],
							"L_ENTERED_ON" => $lang['Entered_on'],
							"L_TITLE" => $lang['Title'],
							"L_COMMENT" => $lang['Comment'],
							"L_SUBMIT_CHANGES" => $lang['Submit_changes'],
							"L_GO_BACK" => $lang['Go_back'])
					);
				} elseif ($delete_comment) {
					$smarty->assign(array(
							"show_confirm_delete_comment" => "true",
							"L_COMMENT_DELETE_CONFIRMATION" => $lang['Comment_delete_confirmation'],
							"cid" => $cid,
							"eid" => $eid,
							"L_DELETE" => $lang['Delete'],
							"L_GO_BACK" => $lang['Go_back'])
					);
				} elseif ($confirm_delete_comment){
					$sql = "DELETE FROM " . TABLE_PRE . "comments WHERE commentid='$cid'";
					$db->query($sql);
					$smarty->assign(array(
							"show_main_page" => "true",
							"show_comment_deleted" => "true",
							"L_RETURN_TO_COMMENTS" => sprintf($lang['Return_to_comments'], "<a href=\"past.php?eid=${eid}#comments\">", "Go back to entry", "</a>"),
							"L_COMMENT_DELETED" => $lang['Comment_deleted'])
					);
				}
			} else {
				$smarty->assign(array(
						"show_not_allowed" => "true",
						"L_NOT_ALLOWED" => $lang['Not_allowed'])
				);
			}
		}
		$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE eid=$eid";
		$result = $db->query($sql);
		$myrow = $result->fetchRow();
		$result->free();
		$entry = $myrow[3];
		$entry_time = $myrow[1];
		$entry_time = formatDate($entry_time);
		$entry_title = $myrow[2];
		$entry_title = str_replace('\"', '&#34;', $entry_title);
		$entry_title = str_replace('\'', '&#39;', $entry_title);
		if ($cancel) {
			echo "<meta http-equiv='refresh' content='0;URL=past.php?eid=$eid'>";
		} else {
			if ($delete) {
				$smarty->assign(array(
						"show_main_page" => "true",
						"show_delete_entry" => "true",
						"eid" => $eid,
						"L_DELETE_CONFIRMATION" => sprintf($lang['Delete_confirmation'], $entry_title),
						"L_DELETE" => $lang['Delete'],
						"L_GO_BACK" => $lang['Go_back'])
				);
			} else {
				if ($delete2) {
					$sql = "DELETE FROM " . TABLE_PRE . "journalness WHERE eid=$eid";
					$db->query($sql);
					$sql = "DELETE FROM " . TABLE_PRE . "comments WHERE eid=$eid";
					$db->query($sql);
					$entry_title = str_replace('\\', '', $entry_title);
					$smarty->assign(array(
							"show_main_page" => "true",
							"show_entry_deleted" => "true",
							"L_ENTRY_DELETED" => sprintf($lang['Entry_deleted'], $entry_title),
							"L_RETURN_TO_INDEX" => $lang['Return_to_index'])
					);
				} else {
					if ($edit || $submit) {
						$sql = "SELECT path, imagename FROM " . TABLE_PRE . "uploads WHERE poster = '".$a->getUsername()."'";
						$result = $db->query($sql);
						$pictures = array();
						$pictures['nothing'] = $lang['Select_picture'];
						while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
							$pictures[$myrow['path']] = $myrow['imagename'];
						}
						$result->free();
						$smarty->assign(array(
								"picture_options" => $pictures,
								"pictures" => "nothing",
								"show_modify_entry" => "true",
								"entry_title" => $entry_title,
								"entry_time" => $entry_time,
								"eid" => $eid,
								"user" => $user,
								"entry" => $entry,
								"L_EDITING_ENTRY" => $lang['Editing_entry'],
								"L_ENTERED_ON" => $lang['Entered_on'],
								"L_TITLE" => $lang['Title'],
								"L_ENTRY" => $lang['Entry'],
								"L_UPLOAD_IMAGE" => $lang['Upload_image'],
								"L_PREVIEW_CHANGES" => $lang['Preview_changes'],
								"L_SUBMIT_CHANGES" => $lang['Submit_changes'],
								"L_GO_BACK" => $lang['Go_back'])
						);
					} elseif (!$edit_comment && !$delete_comment) {
					}
				}
			}
		}
	} else {
		$smarty->assign(array(
				"show_not_allowed" => "true",
				"L_NOT_ALLOWED" => $lang['Not_allowed'])
		);
	}
} else {
	$smarty->assign(array(
			"show_not_logged_in" => "true",
			"L_NOT_LOGGED_IN_EDIT" => $lang['Not_logged_in_edit'],
			"L_LOGIN_LINK" => $lang['Login_link'])
	);
}
$smarty->display("$def_theme/modify.tpl");
?>
