<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if (!isset($srch)) {
	$srch = $search;
} else {
	$srch = $_POST['srch'];
}
$offset = $_GET['offset'];
$usr = $_GET['usr'];
$searchvar = $_GET['search'];
if (isset($searchvar)) {
	$srch = $_GET['search'];
} else {
	$srch = $_POST['srch'];
}
if ((!$srch) && (!$usr) && (!$offset)) {
	$smarty->assign(array(
			"show_search_page" => "true",
			"L_SEARCH_MESSAGE" => $lang['Search_message'])
	);
} else {
	if (($srch) && (!$usr)) {
		$limit = 15; // rows to return
		if ($a->getUsername() == $admin_name) {
			/* Admin can search by IP */
			$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE entry LIKE '%$srch%' OR entry_time LIKE '%$srch%' OR entry_title LIKE '%$srch%' OR poster LIKE '%$srch%' OR ip LIKE '%$srch%' ORDER BY entry_time DESC";
			$numresults = $db->query($sql);
		} else {
			$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE entry LIKE '%$srch%' OR entry_time LIKE '%$srch%' OR entry_title LIKE '%$srch%' OR poster LIKE '%$srch%' ORDER BY entry_time DESC";
			$numresults = $db->query($sql);
		}
		$numrows = $numresults->numRows();
		$numresults->free();
		// next determine if an offset has been passed to script, if not use 0
		if (empty($offset)) {
			$offset = 0;
		}
		// get results
		if ($a->getUsername() == $admin_name) {
			/* Admin can search by IP */
			$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE entry LIKE '%$srch%' OR entry_time LIKE '%$srch%' OR entry_title LIKE '%$srch%' OR poster LIKE '%$srch%' OR ip LIKE '%$srch%' ORDER BY entry_time DESC LIMIT $limit OFFSET $offset";
			$result = $db->query($sql);
		} else {
			$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE entry LIKE '%$srch%' OR entry_time LIKE '%$srch%' OR entry_title LIKE '%$srch%' OR poster LIKE '%$srch%' ORDER BY entry_time DESC LIMIT $limit OFFSET $offset";
			$result = $db->query($sql);
		}
		// now you can display the results returned
		while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)){
			$myrow['entry_time'] = formatDate($myrow['entry_time']);
			$entries[] = $myrow;
		}
		$result->free();
		$smarty->assign(array(
				"entries" => $entries,
				"show_search_nav" => "true",
				"search" => $srch,
				"L_SEARCH_RESULTS" => $lang['Search_results'],
				"L_DATE_ENTERED" => $lang['Date_entered'],
				"L_TITLE" => $lang['Past_title'],
				"L_POSTED_BY" => $lang['Past_posted_by'])
		);
		// next we need to do the links to other results
		if ($offset > 1) {
			$prevoffset = $offset-15;
			$smarty->assign(array(
					"show_prev" => "true",
					"prevoffset" => $prevoffset,
					"L_PREV" => $lang['Prev'])
			);
		}
		// calculate number of pages needing links
		$pages = intval($numrows/$limit);
		// $pages now contains int of pages needed unless there is a remainder from division
		if ($numrows%$limit) {
			// has remainder so add one page
			$pages++;
		}
		$smarty->assign('pages', $pages);
		$smarty->assign('offset', $offset);
		$smarty->assign('limit', $limit);
		$newoffset = $limit * ($i-1);
		$smarty->assign('newoffset', $newoffset);
		// check to see if last page
		$pages--;
		if ((($offset/$limit) < $pages)) {
			// not last page so give NEXT link
			$newoffset = $offset+$limit;
			$smarty->assign(array(
					"show_next" => "true",
					"newoffset" => $newoffset,
					"L_NEXT" => $lang['Next'])
			);
		}
	}
}
if ($usr && !$srch) {
	$limit = 15; // rows to return
	$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE poster='$usr' ORDER BY entry_time DESC";
	$numresults = $db->query($sql);
	$numrows = $numresults->numRows();
	$numresults->free();
	// next determine if offset has been passed to script, if not use 0
	if (empty($offset)) {
		$offset = 0;
	}
	// get results
	$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE poster='$usr' ORDER BY entry_time DESC LIMIT $limit OFFSET $offset";
	$result = $db->query($sql);
	// now you can display the results returned
	while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)){
		$myrow['entry_time'] = formatDate($myrow['entry_time']);
		$entries[] = $myrow;
	}
	$result->free();
	$smarty->assign(array(
			"entries" => $entries,
			"user" => $usr,
			"L_SEARCH_RESULTS" => $lang['Search_results'],
			"L_DATE_ENTERED" => $lang['Date_entered'],
			"L_TITLE" => $lang['Past_title'],
			"L_POSTED_BY" => $lang['Past_posted_by'])
	);
	// next we need to do the links to other results
	if ($offset > 1) {
		$prevoffset = $offset-15;
		$prevoffset = $offset-15;
		$smarty->assign(array(
				"show_prev" => "true",
				"prevoffset" => $prevoffset,
				"L_PREV" => $lang['Prev'])
		);
	}
	// calculate number of pages needing links
	$pages = intval($numrows/$limit);
	// $pages now contains int of pages needed unless there is a remainder from division
	if ($numrows%$limit) {
		// has remainder so add one page
		$pages++;
	}
	$smarty->assign('pages', $pages);
	$smarty->assign('offset', $offset);
	$smarty->assign('limit', $limit);
	$newoffset = $limit * ($i-1);
	$smarty->assign('newoffset', $newoffset);
	// check to see if last page
	$pages--;
	if ((($offset/$limit) < $pages)) {
		// not last page so give NEXT link
		$newoffset = $offset+$limit;
		$smarty->assign(array(
				"show_next" => "true",
				"newoffset" => $newoffset,
				"L_NEXT" => $lang['Next'])
		);
	}
}
$smarty->display("$def_theme/search.tpl");
?>
