<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

if (!strlen($_SERVER['QUERY_STRING'])) {
	$user_restrict = '';
} else {
	$user_restrict = "WHERE poster = '".str_replace('%20',' ',addslashes($_SERVER['QUERY_STRING']))."'";
}
$sql = "SELECT * FROM " . TABLE_PRE . "journalness " . $user_restrict . " ORDER BY entry_time DESC LIMIT " . $newest_entries;
$result = $db->query($sql);
if (DB::isError($result)){
	die($result->getMessage());
}

$rows = $result->numRows();
if (!$rows) {
	$smarty->assign(array(
			"show_no_entries" => "true",
			"L_NO_ENTRIES" => $lang['No_entries'])
	);
} else {
	while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
		$sql = "SELECT sig,uid FROM " . TABLE_PRE . "users WHERE username = '$myrow[poster]'";
		$uid = $db->query($sql);
		$row = $uid->fetchRow(DB_FETCHMODE_ASSOC);
		$uid->free();
		if($row['sig'] != null) {
			$myrow['entry'] .= "\n\n--------------------\n";
			$myrow['entry'] .= "$row[sig]";
		}
		$myrow['entry'] = str_replace('\n', '<br/>', $myrow['entry']); // to retrieve it
		$myrow['entry'] = str_replace('\r', '', $myrow['entry']); // to retrieve it
		$myrow['entry'] = str_replace('<br>', '\n', $myrow['entry']);
		$myrow['entry'] = bbcodeToHtml($myrow['entry']);
		$myrow['entry_time'] = formatDate($myrow['entry_time']);
		$sql = "SELECT count(*) AS rows FROM " . TABLE_PRE . "comments WHERE eid=" . $myrow['eid'];
		$comments = $db->query($sql);
		if(DB::isError($comments)){
			die($comments->getMessage());
		}
		$numcomments = $comments->fetchRow(DB_FETCHMODE_ASSOC);
		$comments->free();

		if(DB::isError($uid)){
			die($uid->getMessage());
		}

		$myrow['numcomments'] = $numcomments['rows'];
		$myrow['uid'] = $row['uid'];
		$entries[] = $myrow;

	}
	$smarty->assign(array(
			"entries" => $entries,
			"L_POSTED_ON" => $lang['Posted_on'],
			"L_POSTED_BY" => $lang['Posted_by'],
			"L_COMMENTS" => $lang['Comments'],
			"VIEWALL" => $lang['Viewall'])
	);
}
$result->free();
$smarty->display("$def_theme/index.tpl");
?>
