<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');

$eid = $_GET['eid'];
if ($eid) {
	$smarty->assign('show_viewing_entry', 'true');
	$sql = "SELECT * FROM " . TABLE_PRE . "journalness WHERE eid=$eid";
	$result = $db->query($sql);
	$myrow = $result->fetchRow(DB_FETCHMODE_ASSOC);
	$result->free();
	$sql = "SELECT uid,sig FROM " . TABLE_PRE . "users WHERE username='$myrow[poster]'";
	$result = $db->query($sql);
	$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
	$result->free();
	if($row['sig'] != null) {
		$myrow['entry'] .= "\n\n--------------------\n";
		$myrow['entry'] .= "$row[sig]";
	}
	$myrow['entry'] = str_replace('\r', '', $myrow['entry']); // to retrieve it
	$myrow['entry'] = bbcodeToHtml($myrow['entry']);
	

	if($anon_comment == "yes" || $a->checkAuth())
	{
		$smarty->assign('show_comment_form', 'false');
	}
	
	$smarty->assign(array(
			"uid" => $row['uid'],
			"eid" => $myrow['eid'],
			"entry_time" => formatDate($myrow['entry_time']),
			"entry_title" => $myrow['entry_title'],
			"entry" => $myrow['entry'],
			"user" => $myrow['poster'],
			"L_POSTED_ON" => $lang['Posted_on'],
			"L_POSTED_BY" => $lang['Posted_by'],
			"L_COMMENTS" => $lang['Comments'],
			"L_ADD_COMMENT" => $lang['Add_comment'],
			"L_TITLE" => $lang['Title'],
			"L_COMMENT" => $lang['Comment'],
			"L_POST_COMMENT" => $lang['Post_comment'])
	);

	if ($a->getUsername() == $admin_name) {
		$smarty->assign('ip', $myrow['ip']);
	}
	if ($a->getUsername() == $myrow['poster'] || $a->getUsername() == $admin_name) {
		$smarty->assign('show_modify_buttons', 'true');
	}
	$sql = "SELECT * FROM " . TABLE_PRE . "comments where eid=$eid";
	$result = $db->query($sql);
	$numcomments = $result->numRows();
	$result->free();
	$smarty->assign('numcomments', $numcomments);
	$smarty->assign('show_comment_loop', 'true');
	// now you can display the results returned
	$sql = "SELECT * FROM " . TABLE_PRE . "comments WHERE eid=$eid ORDER BY commenttime DESC";
	$result = $db->query($sql);
	while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
		if ($myrow['username'] != "Anonymous User") {
			$sql = "SELECT sig FROM " . TABLE_PRE . "users WHERE username = '" . $myrow['username'] . "'";
			$sig = $db->query($sql);
			$row = $sig->fetchRow(DB_FETCHMODE_ASSOC);
			if ($row['sig'] != null) {
				$myrow['comment'] .= "\n\n--------------------\n";
				$myrow['comment'] .= "$row[sig]";
			}
		}
		$myrow['comment'] = bbcodeToHtml($myrow['comment']);
		$myrow['comment'] = str_replace('\r', '', $myrow['comment']); // to retrieve it
		$myrow['commenttime'] = formatDate($myrow['commenttime']);
		$comments[] = $myrow;
	}
	$result->free();
	$smarty->assign('comments', $comments);
	$sql = "SELECT eid FROM " . TABLE_PRE . "journalness WHERE eid < $eid ORDER BY eid DESC LIMIT 1";
	$result = $db->query($sql);
	$prev = $result->fetchRow(DB_FETCHMODE_ASSOC);
	$result->free();
	$smarty->assign(array(
			"prev" => $prev['eid'],
			"L_PREVIOUS_POST" => $lang['Previous_post'])
	);
	$sql = "SELECT eid FROM " . TABLE_PRE . "journalness WHERE eid > $eid ORDER BY eid LIMIT 1";
	$result = $db->query($sql);
	$next = $result->fetchRow(DB_FETCHMODE_ASSOC);
	$result->free();
	$smarty->assign(array(
			"next" => $next['eid'],
			"L_NEXT_POST" => $lang['Next_post'])
	);
} else {
	if (!$eid) {
		$smarty->assign(array(
				"show_titles" => "true",
				"L_ALL_ENTRIES" => $lang['All_entries'],
				"L_DATE_ENTERED" => $lang['Date_entered'],
				"L_PAST_TITLE" => $lang['Past_title'],
				"L_PAST_POSTED_BY" => $lang['Past_posted_by'])
		);
		$offset = $_GET['offset'];
		$limit = 15; // rows to return
		$sql = "SELECT * FROM " . TABLE_PRE . "journalness ORDER BY entry_time DESC";
		$numresults = $db->query($sql);
		$numrows = $numresults->numRows();
		$numresults->free();
		// next determine if offset has been passed to script, if not use 0
		if (empty($offset)) {
			$offset = 0;
		}
		// get results
		$sql = "SELECT * FROM " . TABLE_PRE . "journalness ORDER BY entry_time DESC limit $limit OFFSET $offset";
		$result = $db->query($sql);
		$smarty->assign('show_entry_list', 'true');
		// now you can display the results returned
		while ($myrow = $result->fetchRow(DB_FETCHMODE_ASSOC)){

			$sql = "SELECT uid FROM " . TABLE_PRE . "users WHERE username = '$myrow[poster]'";
			$uid = $db->query($sql);
			$row = $uid->fetchRow(DB_FETCHMODE_ASSOC);
			$uid->free();

			$myrow['entry_time'] = formatDate($myrow['entry_time']);
			$myrow['uid'] = $row['uid'];
			$entries[] = $myrow;
		}
		$result->free();
		$smarty->assign('entries', $entries);
	}
	$smarty->assign('show_end_table', 'true');
	// next we need to do the links to other results
	if ($offset > 1) {
		$prevoffset = $offset-15;
		$smarty->assign(array(
				"show_prev" => "true",
				"L_PREV" => $lang['Prev'],
				"prevoffset" => $prevoffset)
		);
	}
	// calculate number of pages needing links
	$pages = intval($numrows/$limit);
	// $pages now contains int of pages needed unless there is a remainder from division
	if ($numrows%$limit) {
		// has remainder so add one page
		$pages++;
	}
	$newoffset = $limit * ($i-1);
	$smarty->assign('pages', $pages);
	$smarty->assign('offset', $offset);
	$smarty->assign('limit', $limit);
	$smarty->assign('newoffset', $newoffset);
	// check to see if last page
	$pages--;
	if ((($offset/$limit) < $pages)) {
		// not last page so give NEXT link
		$newoffset = $offset+$limit;
		$smarty->assign(array(
				"show_next" => "true",
				"L_NEXT" => $lang['Next'],
				"newoffset" => $newoffset)
		);
	}
	$smarty->assign('show_close_table', 'true');
}
$smarty->display("$def_theme/past.tpl");
?>
