<?php
//  Copyright (C) 2004-2005  Drew Withers
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,

require_once('common.inc.php');
$user_theme = $def_theme;
$mode = $_GET['mode'];
$edit_profile = $_POST['edit_profile'];

if($mode == "editprofile" || $edit_profile){

	if($a->checkAuth() && $mode == "editprofile"){
		$sql = "SELECT * FROM " . TABLE_PRE . "users WHERE username = '".$a->getUsername()."'";
		$result = $db->query($sql);
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$result->free();

		$smarty->assign(array(
				"show_edit_profile" => "true",
				"show_user_links" => "true",
				"allow_username_change" => $allow_username_change,
				"L_EDIT_PROFILE" => $lang['Edit_profile'],
				"L_REGISTRATION_INFORMATION" => $lang['Registration_information'],
				"L_REQUIRED_FIELDS" => $lang['Required_fields'],
				"L_PROFILE_USERNAME" => $lang['Profile_username'],
				"L_PROFILE_EMAIL" => $lang['Profile_email'],
				"L_EMAIL_VIEWABLE" => $lang['Email_viewable'],
				"L_YES" => $lang['Yes'],
				"L_NO" => $lang['No'],
				"L_NEW_PASSWORD" => $lang['New_password'],
				"L_CONFIRM_NEW_PASSWORD" => $lang['Confirm_new_password'],
				"L_CHANGING_PASSWORD" => $lang['Changing_password'],
				"L_PROFILE_INFORMATION" => $lang['Profile_information'],
				"L_USER_LANGUAGE" => $lang['User_language'],
				"L_USER_THEME" => $lang['User_theme'],
				"cust_options" => $languages,
				"theme_options" => $themes,
				"def_lang" => $row[def_user_lang],
				"def_theme" => $row[def_user_theme],
				"L_REAL_NAME" => $lang['Real_name'],
				"L_AGE" => $lang['Age'],
				"L_SEX" => $lang['Sex'],
				"L_MALE" => $lang['Male'],
				"L_FEMALE" => $lang['Female'],
				"L_ICQ" => $lang['ICQ'],
				"L_AIM" => $lang['AIM'],
				"L_YIM" => $lang['YIM'],
				"L_MSN" => $lang['MSN'],
				"L_WEBSITE" => $lang['Website'],
				"L_WEB_EXAMPLE" => $lang['Web_example'],
				"L_LOCATION" => $lang['Location'],
				"L_SUBMIT" => $lang['Submit'],
				"L_PLAINTEXT_WARNING" => $lang['Plaintext_warning'])
		);
		$smarty->assign($row);

		if($validation == "yes"){
			$smarty->assign("L_CHANGING_EMAIL", $lang['Changing_email']);
		}

		$smarty->display("$user_theme/profile.tpl");
	} elseif($a->checkAuth() && $edit_profile) {
		$user = htmlspecialchars($_POST['user']);
		$originalemail = htmlspecialchars($_POST['originalemail']);
		$email = htmlspecialchars($_POST['email']);
		$email_public = $_POST['email_public'];
		$pass = $_POST['pass'];
		$newpass = $_POST['newpass'];
		$newpassconf = $_POST['conf'];

		if ($crypt_type != 'none') {
			$salt = '7b949c8716';
		} else {
			$salt = '';
		}

		if($newpass && $newpassconf){
			if($newpass == $newpassconf){
				$a->changePassword($a->getUsername(),$newpass . $salt);
			}
				
		}		

		if($originalemail != $email){
			if($validation == "yes"){
				$sql = "UPDATE " . TABLE_PRE . "users SET email = '$email', verified = '0' WHERE username = '". $a->getUsername() ."'";
				$db->query($sql);
				sendAuthEmail($a->getUsername());
			}elseif($validation == "no"){
				$sql = "UPDATE " . TABLE_PRE . "users SET email = '$email' WHERE username = '". $a->getUsername() ."'";
				$db->query($sql);
			}
		}elseif($originalemail == $email){
			
		}

		$_POST['realname'] = htmlspecialchars($_POST['realname']);
		$_POST['icq'] = htmlspecialchars($_POST['icq']);
		$_POST['aim'] = htmlspecialchars($_POST['aim']);
		$_POST['yim'] = htmlspecialchars($_POST['yim']);
		$_POST['msn'] = htmlspecialchars($_POST['msn']);
		$_POST['website'] = htmlspecialchars($_POST['website']);
		$_POST['location'] = htmlspecialchars($_POST['location']);

		$sql = "UPDATE " . TABLE_PRE . "users SET email_public = '$email_public', def_user_lang = '$_POST[def_user_lang]', def_user_theme = '$_POST[def_user_theme]', realname = '$_POST[realname]',";
		if($_POST[age] == "nothing" || $_POST[age] == "0" || $_POST[age] == ""){
			$sql .= "age = NULL, ";
		}else{
			$sql .= "age = $_POST[age], ";
		}
		$sql .= "sex = '$_POST[sex]', icq = '$_POST[icq]', aim = '$_POST[aim]', yim = '$_POST[yim]', 
		msn = '$_POST[msn]', website = '$_POST[website]', location = '$_POST[location]' WHERE
		username = '". $a->getUsername() ."'";
		$db->query($sql);

		$smarty->assign(array(
				"show_profile_updated" => "true",
				"L_PROFILE_UPDATED_TITLE" => $lang['Profile_updated_title'],
				"L_PROFILE_UPDATED" => $lang['Profile_updated'],
				"L_RETURN_TO_INDEX" => $lang['Return_to_index'])
		);

		$smarty->display("$user_theme/profile.tpl");
	} else {
		header('Location: login.php');
		exit;
	}

}elseif($mode == "viewprofile"){

	$user = $_GET['user'];
	if($user){

		$sql = "SELECT username, email, email_public, realname, age, sex, icq, aim, yim, msn, website, location FROM 	
		" . TABLE_PRE . "users WHERE uid = '$user'";
		$result = $db->query($sql);
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$result->free();
	
		if($row[email_public] == "0"){
			$row[email] = $lang['Email_not_public'];
		}else{
			$row[email] = mail_mash($row[email]);
			$row[email] = "<a href=\"$row[email]\">$lang[Email_title] $row[username]</a>";
		}

		$sql = "SELECT eid FROM " . TABLE_PRE . "journalness WHERE poster = '$row[username]'";
		$result = $db->query($sql);
		$numentries = $result->numRows();
		$result->free();

		$smarty->assign(array(
				"show_view_profile" => "true",
				"numentries" => $numentries,
				"L_VIEWING_PROFILE" => sprintf($lang['Viewing_profile'], $row[username]),
				"L_CONTACT_INFORMATION" => sprintf($lang['Contact_information'], $row[username]),
				"L_VIEW_PROFILE_INFORMATION" => sprintf($lang['View_profile_information'], $row[username]),
				"L_EMAIL_ADDRESS" => $lang['Email_address'],
				"L_ICQ" => $lang['ICQ'],
				"L_AIM" => $lang['AIM'],
				"L_YIM" => $lang['YIM'],
				"L_MSN" => $lang['MSN'],
				"L_TOTAL_ENTRIES" => $lang['Total_entries'],
				"L_FIND_ALL_POSTS" => sprintf($lang['Find_all_posts'], $row[username]),
				"L_VIEW_RECENT_POSTS" => sprintf($lang['View_recent_posts'], $row[username]),
				"L_REAL_NAME" => $lang['Real_name'],
				"L_AGE" => $lang['Age'],
				"L_SEX" => $lang['Sex'],
				"L_MALE" => $lang['Male'],
				"L_FEMALE" => $lang['Female'],
				"L_WEBSITE" => $lang['Website'],
				"L_LOCATION" => $lang['Location'])
		);
		$smarty->assign($row);

		$smarty->display("$user_theme/profile.tpl");

	}else
	{
		$smarty->assign(array(
				"show_noprofile" => "true",
				"L_USER_NO_EXIST" => $lang['User_no_exist'])
				);
		$smarty->display("$user_theme/profile.tpl");

	}

}

?>
